//+-------------------------------------------------------------------------------------------+
//|                                                                  Pattern Candlestick.mq4  |
//                 long > 2*average body > medium > average/2 > short > average/4 > doji      |
//+-------------------------------------------------------------------------------------------+
#property copyright "herman"
#property link      "http://www.interbank99.blogspot.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Blue
//----------------------------------------------------------------------------------------------------------------
extern bool Display_Bearish_Harami = true;
extern bool Display_Bullish_Harami = true;
extern bool Display_Bearish_Harami_Cross = true;
extern bool Display_Bullish_Harami_Cross = true;
extern bool Display_Bearish_Engulfing = true;
extern bool Display_Bullish_Engulfing = true;
extern bool Display_Bearish_Inverted_Hammer = true;
extern bool Display_Bullish_Inverted_Hammer = true;
extern bool Display_Bearish_Pigeon = true;
extern bool Display_Bullish_Pigeon = true;
extern bool Display_Bearish_Pigeon_Cross = true;
extern bool Display_Bullish_Pigeon_Cross = true;
extern bool Display_Bearish_Kicking = true;
extern bool Display_Bullish_Kicking = true;
extern bool Display_Bearish_Meeting_Lines = true;
extern bool Display_Bullish_Meeting_Lines = true;
extern bool Display_Bearish_Piercing = true;
extern bool Display_Bullish_Piercing = true;
extern bool Display_Bearish_Shooting_Star = true;
extern bool Display_Bullish_Shooting_Star = true;
extern bool Display_Bearish_Cloud = true;
extern bool Display_Bullish_Cloud = true;
extern bool Display_Bearish_Match = true;
extern bool Display_Bullish_Match = true;

//---- buffers-----------------------------------------------------------------------------------------------------
double upArrow[];
double downArrow[];
string PatternText[5000];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() 
  {
   SetIndexStyle(0, DRAW_ARROW, 0, 1);
   SetIndexArrow(0, 226);
   SetIndexBuffer(0, downArrow);      
//----
   SetIndexStyle(1, DRAW_ARROW, 0, 1);
   SetIndexArrow(1, 225);
   SetIndexBuffer(1, upArrow);
      
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit() 
  {
   ObjectsDeleteAll(0, OBJ_TEXT);
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   double Range, AvgRange;
   int counter, setalert;
   static datetime prevtime = 0;
   int shift;
   int shift1;
   int shift2;
   int shift3;
   int shift4;
   int shift5;
   int shift6;
   int shift7;
   int shift8;
   int shift9;
   int shift10;
   int shift11;
   int shift12;
   int shift13;
   int shift14;
   int shift15;
   int shift16;
   string pattern, period;
   int setPattern = 0;
   int alert = 0;
   int arrowShift;
   int textShift;
   double O,O1,O2,O3,O4,O5,O6,O7,O8,O9,O10, 
          C,C1,C2,C3,C4,C5,C6,C7,C8,C9,C10, 
          L,L1,L2,L3,L4,L5,L6,L7,L8,L9,L10, 
          H,H1,H2,H3,H4,H5,H6,H7,H8,H9,H10, 
          B,B1,B2,B3,B4,B5,B6,B7,B8,B9,B10,B11, 
          D, D1, K, K1, K2, K3, sumhi1, sumhi2, sumhi3, sumhi4, sumhi5, sumhi6, sumlo1, sumlo2, sumlo3, sumlo4, sumlo5, sumlo6, highest1, highest2, highest3, highest4, highest5, highest6, lowest1, lowest2, lowest3, lowest4, lowest5, lowest6,
          MA,MA1,MA2,MA3,MA4,MA5,MA6,MA7,MA8,MA9,MA10,MA11;     
//--------------------------------------------------------------------------------------------------------------------
   if(prevtime == Time[0]) 
     {
       return(0);
     }
   prevtime = Time[0];   
//-------------------------------------------------------------------------------------------------------------------
   switch(Period()) 
     {
       case 1:     period = "M1";  break;
       case 5:     period = "M5";  break;
       case 15:    period = "M15"; break;
       case 30:    period = "M30"; break;      
       case 60:    period = "H1";  break;
       case 240:   period = "H4";  break;
       case 1440:  period = "D1";  break;
       case 10080: period = "W1";  break;
       case 43200: period = "MN";  break;
     }
//-------------------------------------------------------------------------------------------------------------------
   for(int j = 0; j < Bars; j++) 
     { 
       PatternText[j] = "pattern-" + j;
     }
//--------------------------------------------------------------------------------------------------------------------
   for(shift = 0; shift < Bars; shift++) 
     {
       setalert = 0;
       counter = shift;
       Range = 0;
       AvgRange = 0;
       for(counter = shift; counter <= shift + 9; counter++) 
         {
           AvgRange = AvgRange + MathAbs(High[counter] - Low[counter]);
         }
       Range = AvgRange / 10;
       shift1 = shift + 1;
       shift2 = shift + 2;
       shift3 = shift + 3;
       shift4 = shift + 4;
       shift5 = shift + 5;
       shift6 = shift + 6;   
       shift7 = shift + 7;      
       shift8 = shift + 8;      
       shift9 = shift + 9;      
       shift10 = shift + 10;      
       shift11 = shift + 11;   
       shift12 = shift + 12;      
       shift13 = shift + 13;      
       shift14 = shift + 14;      
       shift15 = shift + 15;    
       shift16 = shift + 16;      
       O = Open[shift1];
       O1 = Open[shift2];
       O2 = Open[shift3];
       O3 = Open[shift4];
       O4 = Open[shift5];
       O5 = Open[shift6];
       O6 = Open[shift7];
       O7 = Open[shift8];
       O8 = Open[shift9];
       O9 = Open[shift10];
       O10 = Open[shift11];
       H = High[shift1];
       H1 = High[shift2];
       H2 = High[shift3];
       H3 = High[shift4];
       H4 = High[shift5];
       H5 = High[shift6];
       H6 = High[shift7];
       H7 = High[shift8];
       H8 = High[shift9];
       H9 = High[shift10];
       H10 = High[shift11];
       L = Low[shift1];
       L1 = Low[shift2];
       L2 = Low[shift3];
       L3 = Low[shift4];
       L4 = Low[shift5];
       L5 = Low[shift6];
       L6 = Low[shift7];
       L7 = Low[shift8];
       L8 = Low[shift9];
       L9 = Low[shift10];
       L10 = Low[shift11];
       C = Close[shift1];
       C1 = Close[shift2];
       C2 = Close[shift3];
       C3 = Close[shift4];
       C4 = Close[shift5];
       C5 = Close[shift6];
       C6 = Close[shift7];
       C7 = Close[shift8];
       C8 = Close[shift9];
       C9 = Close[shift10];
       C10 = Close[shift11];
       B  = MathAbs (Open[shift1] - Close[shift1]);
       B1  = MathAbs (Open[shift2] - Close[shift2]);
       B2  = MathAbs (Open[shift3] - Close[shift3]);
       B3  = MathAbs (Open[shift4] - Close[shift4]);
       B4  = MathAbs (Open[shift5] - Close[shift5]);
       B5  = MathAbs (Open[shift6] - Close[shift6]);
       B6  = MathAbs (Open[shift7] - Close[shift7]);
       B7  = MathAbs (Open[shift8] - Close[shift8]);
       B8  = MathAbs (Open[shift9] - Close[shift9]);
       B9  = MathAbs (Open[shift10] - Close[shift10]);
       B10 = MathAbs (Open[shift11] - Close[shift11]);
       B11 =  MathAbs (Open[shift12] - Close[shift12]);
       highest1 = MathMax (MathMax(MathMax (High[shift1],High[shift2]), MathMax (High[shift3],High[shift4])) , High[shift5] )   ;
       highest2 = MathMax (MathMax(MathMax (High[shift2],High[shift3]), MathMax (High[shift4],High[shift5])) , High[shift6] )   ;
       highest3 = MathMax (MathMax(MathMax (High[shift3],High[shift4]), MathMax (High[shift5],High[shift6])) , High[shift7] )   ;
       highest4 = MathMax (MathMax(MathMax (High[shift4],High[shift5]), MathMax (High[shift6],High[shift7])) , High[shift8] )   ;
       highest5 = MathMax (MathMax(MathMax (High[shift5],High[shift6]), MathMax (High[shift7],High[shift8])) , High[shift9] )   ;
       highest6 = MathMax (MathMax(MathMax (High[shift6],High[shift7]), MathMax (High[shift8],High[shift9])) , High[shift10] )   ;
       lowest1 = MathMin (MathMin(MathMin (Low[shift1],Low[shift2]), MathMin (Low[shift3],Low[shift4])) , Low[shift5] )   ;
       lowest2 = MathMin (MathMin(MathMin (Low[shift2],Low[shift3]), MathMin (Low[shift4],Low[shift5])) , Low[shift6] )   ;
       lowest3 = MathMin (MathMin(MathMin (Low[shift3],Low[shift4]), MathMin (Low[shift5],Low[shift6])) , Low[shift7] )   ;
       lowest4 = MathMin (MathMin(MathMin (Low[shift4],Low[shift5]), MathMin (Low[shift6],Low[shift7])) , Low[shift8] )   ;
       lowest5 = MathMin (MathMin(MathMin (Low[shift5],Low[shift6]), MathMin (Low[shift7],Low[shift8])) , Low[shift9] )   ;
       lowest6 = MathMin (MathMin(MathMin (Low[shift6],Low[shift7]), MathMin (Low[shift8],Low[shift9])) , Low[shift10] )   ;
       sumhi1 = highest1 - lowest1 ;
       sumhi2 = highest2 - lowest2 ;
       sumhi3 = highest3 - lowest3 ;
       sumhi4 = highest4 - lowest4 ;
       sumhi5 = highest5 - lowest5 ;
       sumhi6 = highest6 - lowest6 ;
       sumlo1 = Close[shift1]-lowest1 ;
       sumlo2 = Close[shift2]-lowest2 ;
       sumlo3 = Close[shift3]-lowest3 ;
       sumlo4 = Close[shift4]-lowest4 ;
       sumlo5 = Close[shift5]-lowest5 ;
       sumlo6 = Close[shift6]-lowest6 ;
       K = (((sumlo1+sumlo2+sumlo3)/3)/((sumhi1+sumhi2+sumhi3)/3))*100;
       K1 = (((sumlo2+sumlo3+sumlo4)/3)/((sumhi2+sumhi3+sumhi4)/3))*100;
       K2 = (((sumlo3+sumlo4+sumlo5)/3)/((sumhi3+sumhi4+sumhi5)/3))*100;
       K3 = (((sumlo4+sumlo5+sumlo6)/3)/((sumhi4+sumhi5+sumhi6)/3))*100;
       D = ( ( K + K1 + K2 ) / 3 ) ;
       D1 = ( ( K1 + K2 + K3 ) / 3 ) ;
       MA = (Close[shift1]+Close[shift2]+Close[shift3]+Close[shift4]+Close[shift5])/5;
       MA1 = (Close[shift2]+Close[shift3]+Close[shift4]+Close[shift5]+Close[shift6])/5;
       MA2 = (Close[shift3]+Close[shift4]+Close[shift5]+Close[shift6]+Close[shift7])/5;
       MA3 = (Close[shift4]+Close[shift5]+Close[shift6]+Close[shift7]+Close[shift8])/5;
       MA4 = (Close[shift5]+Close[shift6]+Close[shift7]+Close[shift8]+Close[shift9])/5;
       MA5 = (Close[shift6]+Close[shift7]+Close[shift8]+Close[shift9]+Close[shift10])/5;
       MA6 = (Close[shift7]+Close[shift8]+Close[shift9]+Close[shift10]+Close[shift11])/5;
       MA7 = (Close[shift8]+Close[shift9]+Close[shift10]+Close[shift11]+Close[shift12])/5;
       MA8 = (Close[shift9]+Close[shift10]+Close[shift11]+Close[shift12]+Close[shift13])/5;
       MA9 = (Close[shift10]+Close[shift11]+Close[shift12]+Close[shift13]+Close[shift14])/5;
       MA10 = (Close[shift11]+Close[shift12]+Close[shift13]+Close[shift14]+Close[shift15])/5;
       MA11 = (Close[shift12]+Close[shift13]+Close[shift14]+Close[shift15]+Close[shift16])/5;

// Bearish Harami --------------------------------------------------------------------------------------------------------
       if( 
            (C1 > O1) // candle 1 bull
         && (C  <  O) // candle 0 bear
         && ( C1 > O ) //
         && ( O1 < C ) //
         && K > 75
         && D > K
         && D1 < K1
         && B1 >= 2*((B2+B3+B4+B5+B6+B7+B8+B9+B10+B11)/10) // candle 1 Long Body
         && B  >= (( B1+B2+B3+B4+B5+B6+B7+B8+B9+B10 )/40)  // candle 0  > short body
         ) 
         {
           if(Display_Bearish_Harami == true) 
             {
               ObjectCreate(PatternText[shift], OBJ_TEXT, 0, Time[shift1], 
                            High[shift1] + Range*1.5);
               ObjectSetText(PatternText[shift], "Harami", 7, 
                             "Arial", Red);
               downArrow[shift1] = High[shift1] + Range*0.75;
             }
         }
// Bullish Harami ---------------------------------------------------------------------------------------------------------
       if(
            (C1 < O1) // candle 1 bear
         && (C  >  O) // candle 0 bull
         && ( C1 < O ) //
         && ( O1 > C ) //
         && K < 25
         && D < K
         && D1 > K1
         && B1 >= 2*((B2+B3+B4+B5+B6+B7+B8+B9+B10+B11)/10) // candle 1 Long Body
         && B  >= (( B1+B2+B3+B4+B5+B6+B7+B8+B9+B10 )/40)  // candle 0 > short body

         ) 
         {
           if(Display_Bullish_Harami == true) 
             {   
               ObjectCreate(PatternText[shift], OBJ_TEXT, 0, Time[shift1], 
                            Low[shift1] - Range*1.5);
               ObjectSetText(PatternText[shift], "Harami", 7, 
                             "Arial", Blue);
               upArrow[shift1] = Low[shift1] - Range*0.75;

             }
         }
// Bearish Harami cross --------------------------------------------------------------------------------------------------
       if( 
            (C1 > O1) // candle 1 bull
         && (C <= O)  // candle 0 bear cross
         && ( C1 > O )  //
         && ( O1 < C )  //
         && K > 75
         && D > K
         && D1 < K1
         && B1 >= 2*((B2+B3+B4+B5+B6+B7+B8+B9+B10+B11)/10) // candle 1 Long Body
         && B  <  ((B1+B2+B3+B4+B5+B6+B7+B8+B9+B10)/40)    // candle 0 doji
         ) 
         {
           if(Display_Bearish_Harami_Cross == true) 
             {
               ObjectCreate(PatternText[shift], OBJ_TEXT, 0, Time[shift1], 
                            High[shift1] + Range*1.5);
               ObjectSetText(PatternText[shift], "Harami +", 7, 
                             "Arial", Red);
               downArrow[shift1] = High[shift1] + Range*0.75;
             }
         }
// Bullish Harami cross --------------------------------------------------------------------------------------------------------
       if(
            (C1 < O1) // candle 1 bear
         && (C >= O)  // candle 0 bull cross
         && ( C1 < O ) //
         && ( O1 > C ) //
         && K < 25
         && D < K
         && D1 > K1
         && B1 >= 2*((B2+B3+B4+B5+B6+B7+B8+B9+B10+B11)/10) // candle 1 Long Body
         && B  <  ((B1+B2+B3+B4+B5+B6+B7+B8+B9+B10)/40)    // candle 0 doji

         ) 
         {
           if(Display_Bullish_Harami_Cross == true) 
             {   
               ObjectCreate(PatternText[shift], OBJ_TEXT, 0, Time[shift1], 
                            Low[shift1] - Range*1.5);
               ObjectSetText(PatternText[shift], "Harami +", 7, 
                             "Arial", Blue);
               upArrow[shift1] = Low[shift1] - Range*0.75;
             }
         }
// Bearish Engulfing --------------------------------------------------------------------------------------------------------
       if( 
            (C1 > O1) // candle 1 bull
         && (C  <  O) // candle 0 bear
         && (C < O1) // Close candle 2 dibawah open candle 1
         && ( O > C1 ) // open candle 2 diatas close candle 1
         && K > 75
         && D > K
         && D1 < K1
         && B >= ((B1+B2+B3+B4+B5+B6+B7+B8+B9+B10)/20) // Candle 0 diatas medium
         ) 
         {
           if(Display_Bearish_Engulfing == true) 
             {
               ObjectCreate(PatternText[shift], OBJ_TEXT, 0, Time[shift1], 
                            High[shift1] + Range*1.5);
               ObjectSetText(PatternText[shift], "Engulfing", 7, 
                             "Arial", Red);
               downArrow[shift1] = High[shift1] + Range*0.75;
             }
         }
// Bullish Engulfing --------------------------------------------------------------------------------------------------------
       if(
            (C1 < O1) // candle 1 bear
         && (C  >  O) // candle 0 bull
         && (C > O1) // Close candle 0 dibawah open candle 1
         && ( O < C1 ) // open candle 0 diatas close candle 1
         && K < 25
         && D < K
         && D1 > K1
         && B >= ((B1+B2+B3+B4+B5+B6+B7+B8+B9+B10)/20) // Candle 0 diatas medium
         
         ) 
         {
           if(Display_Bullish_Engulfing == true) 
             {   
               ObjectCreate(PatternText[shift], OBJ_TEXT, 0, Time[shift1], 
                            Low[shift1] - Range*1.5);
               ObjectSetText(PatternText[shift], "Engulfing", 7, 
                             "Arial", Blue);
               upArrow[shift1] = Low[shift1] - Range*0.75 ;
             }
         }
// Inverted Hammer ----------------------------------------------------------------------------------------------------------
       if( 
            (C1 > O1) // candle 1 bull
            // candle 0 terserah
         && ( C1 < O )
         && ( C1 < C )         
         && K > 75
         && D > K
         && D1 < K1
         && B <= (( B1+B2+B3+B4+B5+B6+B7+B8+B9+B10 )/20) // candle 0 dibawah medium
         && ( H -(MathMax(C,O))) <= ((B1+B2+B3+B4+B5+B6+B7+B8+B9+B10)/40) // ekor 0 atas very short 
         && (((MathMin(C,O)) - L) >= ((B2+B3+B4+B5+B6+B7+B8+B9+B10+B11)/20))  // ekor 1 bawah medium / long

         ) 
         {
           if(Display_Bearish_Inverted_Hammer == true) 
             {
               ObjectCreate(PatternText[shift], OBJ_TEXT, 0, Time[shift1], 
                            High[shift1] + Range*1.5);
               ObjectSetText(PatternText[shift], "I Hammer", 7, 
                             "Arial", Red);
               downArrow[shift1] = High[shift1] + Range*0.75 ;
             }
         }
// Bullish Inverted Hammer -------------------------------------------------------------------------------------------------
       if(
            (C1 < O1) // candle 1 bear
            // candle 0 terserah   
         && ( C1 > O )
         && ( C1 > C ) 
         && K < 25
         && D < K
         && D1 > K1
         && B <= (( B1+B2+B3+B4+B5+B6+B7+B8+B9+B10 )/20) // candle 0 dibawah medium
         && ((MathMin(C,O))-L) <= (( B1+B2+B3+B4+B5+B6+B7+B8+B9+B10)/40) // ekor 0 bawah very short  
         && ( (H-(MathMax(C,O))) >= ((B2+B3+B4+B5+B6+B7+B8+B9+B10+B11)/20)) // ekor 1 atas medium / long

         ) 
         {
           if(Display_Bullish_Inverted_Hammer == true) 
             {   
               ObjectCreate(PatternText[shift], OBJ_TEXT, 0, Time[shift1], 
                            Low[shift1] - Range*1.5);
               ObjectSetText(PatternText[shift], "I Hammer", 7, 
                             "Arial", Blue);
               upArrow[shift1] = Low[shift1] - Range*0.75;
             }
         }
// Bearish Pigeon ---------------------------------------------------------------------------------------------------------
       if( 
            (C1 > O1) // candle 1 bull
         && (C  >  O) // candle 0 bull
         && ( C1 > C ) //
         && ( O1 < O ) //
         && K > 75
         && D > K
         && D1 < K1
         && B1 >= 2*((B2+B3+B4+B5+B6+B7+B8+B9+B10+B11)/10) // candle 1 Long Body
         && B >= ((B1+B2+B3+B4+B5+B6+B7+B8+B9+B10)/40)  // candle 0 > Short body 
         ) 
         {
           if(Display_Bearish_Pigeon == true) 
             {
               ObjectCreate(PatternText[shift], OBJ_TEXT, 0, Time[shift1], 
                            High[shift1] + Range*1.5);
               ObjectSetText(PatternText[shift], "Pigeon", 7, 
                             "Arial", Red);
               downArrow[shift1] = High[shift1] + Range*0.75;
             }
         }
// Bullish Pigeon ---------------------------------------------------------------------------------------------------------
       if(
            (C1 < O1) // candle 1 bear
         && (C  <  O) // candle 0 bear
         && ( C1 < C ) //
         && ( O1 > O ) //
         && K < 25
         && D < K
         && D1 > K1
         && B1 >= 2*((B2+B3+B4+B5+B6+B7+B8+B9+B10+B11)/10) // candle 1 Long Body
         && B >= (( B1+B2+B3+B4+B5+B6+B7+B8+B9+B10)/40)  // candle 0 > short body

         ) 
         {
           if(Display_Bullish_Pigeon == true) 
             {   
               ObjectCreate(PatternText[shift], OBJ_TEXT, 0, Time[shift1], 
                            Low[shift1] - Range*1.5);
               ObjectSetText(PatternText[shift], "Pigeon", 7, 
                             "Arial", Blue);
               upArrow[shift1] = Low[shift1] - Range*0.75;
             }
         }
// Bearish pigeon cross ---------------------------------------------------------------------------------------------------
       if( 
            (C1 > O1) // candle 1 bull
         && (C >= O)  // candle 0 bull cross
         && ( C1 > C ) //
         && ( O1 < O ) //
         && K > 75
         && D > K
         && D1 < K1
         && B1 >= 2*((B2+B3+B4+B5+B6+B7+B8+B9+B10+B11)/10) // candle 1 Long Body
         && B < (( B1+B2+B3+B4+B5+B6+B7+B8+B9+B10 )/40) 
         ) 
         {
           if(Display_Bearish_Pigeon_Cross == true) 
             {
               ObjectCreate(PatternText[shift], OBJ_TEXT, 0, Time[shift1], 
                            High[shift1] + Range*1.5);
               ObjectSetText(PatternText[shift], "Pigeon +", 7, 
                             "Arial", Red);
               downArrow[shift1] = High[shift1] + Range*0.75;
             }
         }
// Bullish pigeon cross -----------------------------------------------------------------------------------------------------
       if(
            (C1 < O1) // candle 1 bear
         && (C <= O)  // candle 0 bear cross
         && ( C1 < C ) //
         && ( O1 > O ) //
         && K < 25
         && D < K
         && D1 > K1
         && B1 >= 2*((B2+B3+B4+B5+B6+B7+B8+B9+B10+B11)/10) // candle 1 Long Body
         && B < (( B1+B2+B3+B4+B5+B6+B7+B8+B9+B10)/40) 

         ) 
         {
           if(Display_Bullish_Pigeon_Cross == true) 
             {   
               ObjectCreate(PatternText[shift], OBJ_TEXT, 0, Time[shift1], 
                            Low[shift1] - Range*1.5);
               ObjectSetText(PatternText[shift], "Pigeon +", 7, 
                             "Arial", Blue);
               upArrow[shift1] = Low[shift1] - Range*0.75;
             }
         }
// Bearish Kicking -----------------------------------------------------------------------------------------------------------
       if( 
            (C1 > O1) // candle 1 bull
         && (C  <  O) // candle 0 bear
         && ( O1 > C ) //
         && ( O1 > O ) //
         && K > 75
         && D > K
         && D1 < K1
         ) 
         {
           if(Display_Bearish_Kicking == true) 
             {
               ObjectCreate(PatternText[shift], OBJ_TEXT, 0, Time[shift1], 
                            High[shift1] + Range*1.5);
               ObjectSetText(PatternText[shift], "Kicking", 7, 
                             "Arial", Red);
               downArrow[shift1] = High[shift1] + Range*0.75;
             }
         }
// Bullish Kicking ------------------------------------------------------------------------------------------------------------
       if(
            (C1 < O1) // candle 1 bear
         && (C  >  O) // candle 0 bull
         && ( O > O1 ) //
         && ( O > C1 ) //
         && K < 25
         && D < K
         && D1 > K1
         ) 
         {
           if(Display_Bullish_Kicking == true) 
             {   
               ObjectCreate(PatternText[shift], OBJ_TEXT, 0, Time[shift1], 
                            Low[shift1] - Range*1.5);
               ObjectSetText(PatternText[shift], "Kicking", 7, 
                             "Arial", Blue);
               upArrow[shift1] = Low[shift1] - Range*0.75;

             }
         }
// Bearish Meeting Lines ------------------------------------------------------------------------------------------------------
       if( 
            (C1 > O1) // candle 1 bull
         && (C  <  O) // candle 0 bear
         && ( C1 <= C ) // close 
         && K > 75
         && D > K
         && D1 < K1
         && B1 >= 2*((B2+B3+B4+B5+B6+B7+B8+B9+B10+B11)/10) // candle 1 Long Body
         ) 
         {
           if(Display_Bearish_Meeting_Lines == true) 
             {
               ObjectCreate(PatternText[shift], OBJ_TEXT, 0, Time[shift1], 
                            High[shift1] + Range*1.5);
               ObjectSetText(PatternText[shift], "Meeting", 7, 
                             "Arial", Red);
               downArrow[shift1] = High[shift1] + Range*0.75;
             }
         }
// Bullish Meeting Lines ------------------------------------------------------------------------------------------------------
       if(
            (C1 < O1) // candle 1 bear
         && (C  >  O) // candle 0 bull
         && ( C1 >= C ) // Close candle 1 sama dengan close candle ke 2 
         && K < 25
         && D < K
         && D1 > K1
         && B1 >= 2*((B2+B3+B4+B5+B6+B7+B8+B9+B10+B11)/10) // candle 1 Long Body

         ) 
         {
           if(Display_Bullish_Meeting_Lines == true) 
             {   
               ObjectCreate(PatternText[shift], OBJ_TEXT, 0, Time[shift1], 
                            Low[shift1] - Range*1.5);
               ObjectSetText(PatternText[shift], "Meeting", 7, 
                             "Arial", Blue);
               upArrow[shift1] = Low[shift1] - Range*0.75;
             }
         }
// Bearish Piercing    ------------------------------------------------------------------------------------------------------
       if( 
            (C1 > O1) // candle 1 bull
         && (C  <  O) // candle 0 bear
         && (O  > C1)
         && (C  > O1)
         && C < (O1 +(B1/2)) // close candle 0 di bawah mid body candle 1         
         && K > 75
         && D > K
         && D1 < K1
         && B1 >= 2*((B2+B3+B4+B5+B6+B7+B8+B9+B10+B11)/10) // candle 1 Long Body
         && B >= ((B1+B2+B3+B4+B5+B6+B7+B8+B9+B10)/20) // Candle 0 diatas medium
         ) 
         {
           if(Display_Bearish_Piercing == true) 
             {
               ObjectCreate(PatternText[shift], OBJ_TEXT, 0, Time[shift1], 
                            High[shift1] + Range*1.5);
               ObjectSetText(PatternText[shift], "Piercing", 7, 
                             "Arial", Red);
               downArrow[shift1] = High[shift1] + Range*0.75;
             }
         }
// Bullish Piercing     ------------------------------------------------------------------------------------------------------
       if(
            (C1 < O1) // candle 1 bear
         && (C  >  O) // candle 0 bull
         && (O  < C1)
         && (C  < O1)
         && C > (C1+(B1/2)) // close candle 0 diatas mid body 2
         && K < 25
         && D < K
         && D1 > K1
         && B1 >= 2*((B2+B3+B4+B5+B6+B7+B8+B9+B10+B11)/10) // candle 1 Long Body
         && B >= ((B1+B2+B3+B4+B5+B6+B7+B8+B9+B10)/20) // Candle 0 diatas medium

         ) 
         {
           if(Display_Bullish_Piercing == true) 
             {   
               ObjectCreate(PatternText[shift], OBJ_TEXT, 0, Time[shift1], 
                            Low[shift1] - Range*1.5);
               ObjectSetText(PatternText[shift], "Piercing", 7, 
                             "Arial", Blue);
               upArrow[shift1] = Low[shift1] - Range*0.75;
             }
         }
// Bearish Shooting Star    ------------------------------------------------------------------------------------------------------
       if( 
            (C1 > O1) // candle 1 bull
         && C1 < (MathMin(O,C))
         && K > 75
         && D > K
         && D1 < K1
         && B1 >= 2*((B2+B3+B4+B5+B6+B7+B8+B9+B10+B11)/10) // candle 1 Long Body
         && B <= ((B1+B2+B3+B4+B5+B6+B7+B8+B9+B10)/20) // candle 0 short
         && ((MathMin(C,O))-L) <= (( B1+B2+B3+B4+B5+B6+B7+B8+B9+B10)/40) // ekor 0 bawah very short  
         && ( (H-(MathMax(C,O))) >= ((B2+B3+B4+B5+B6+B7+B8+B9+B10+B11)/20)) // ekor 1 atas medium / long
         ) 
         {
           if(Display_Bearish_Shooting_Star == true) 
             {
               ObjectCreate(PatternText[shift], OBJ_TEXT, 0, Time[shift1], 
                            High[shift1] + Range*1.5);
               ObjectSetText(PatternText[shift], "Shoot", 7, 
                             "Arial", Red);
               downArrow[shift1] = High[shift1] + Range*0.75;
             }
         }
// Bullish Shooting Star    ------------------------------------------------------------------------------------------------------
       if(
            (C1 < O1) // candle 1 bear
         && C1 > (MathMax(O,C)) 
         && K < 25
         && D < K
         && D1 > K1
         && B1 >= 2*((B2+B3+B4+B5+B6+B7+B8+B9+B10+B11)/10) // candle 1 Long Body
         && B <= ((B1+B2+B3+B4+B5+B6+B7+B8+B9+B10)/20) // candle 0 short
         && ( H -(MathMax(C,O))) <= ((B1+B2+B3+B4+B5+B6+B7+B8+B9+B10)/40) // ekor 0 atas very short 
         && (((MathMin(C,O)) - L) >= ((B2+B3+B4+B5+B6+B7+B8+B9+B10+B11)/20))  // ekor 1 bawah medium / long
         ) 
         {
           if(Display_Bullish_Shooting_Star == true) 
             {   
               ObjectCreate(PatternText[shift], OBJ_TEXT, 0, Time[shift1], 
                            Low[shift1] - Range*1.5);
               ObjectSetText(PatternText[shift], "Shoot", 7, 
                             "Arial", Blue);
               upArrow[shift1] = Low[shift1] - Range*0.75;
             }
         }
// Bearish Cloud       ------------------------------------------------------------------------------------------------------
       if( 
            (C1 > O1) // candle 1 bull
         && (C  <  O) // candle 0 bear
         && (O  > H1)
         && C < (C1-(B1/2)) // close candle 0 di bawah mid body candle 1
         && K > 75
         && D > K
         && D1 < K1
         && B1 >= 2*((B2+B3+B4+B5+B6+B7+B8+B9+B10+B11)/10) // candle 1 Long Body
         ) 
         {
           if(Display_Bearish_Cloud == true) 
             {
               ObjectCreate(PatternText[shift], OBJ_TEXT, 0, Time[shift1], 
                            High[shift1] + Range*1.5);
               ObjectSetText(PatternText[shift], "Cloud", 7, 
                             "Arial", Red);
               downArrow[shift1] = High[shift1] + Range*0.75;
             }
         }
// Bullish Cloud       ------------------------------------------------------------------------------------------------------
       if(
            (C1 < O1) // candle 1 bear
         && (C  >  O) // candle 0 bull
         && (O  <  L1)
         && K < 25
         && D < K
         && D1 > K1
         && B1 >= 2*((B2+B3+B4+B5+B6+B7+B8+B9+B10+B11)/10) // candle 1 Long Body
         && C > (C1+(B1/2)) // close candle 0 diatas mid body 2
         ) 
         {
           if(Display_Bullish_Cloud == true) 
             {   
               ObjectCreate(PatternText[shift], OBJ_TEXT, 0, Time[shift1], 
                            Low[shift1] - Range*1.5);
               ObjectSetText(PatternText[shift], "Cloud", 7, 
                             "Arial", Blue);
               upArrow[shift1] = Low[shift1] - Range*0.75;
             }
         }
// Bearish Match       ------------------------------------------------------------------------------------------------------
       if( 
            (C1 > O1) // candle 1 bull
         && (C  >  O) // candle 0 bull
         && (C1 == C)
         && K > 75
         && D > K
         && D1 < K1
         && B1 >= 2*((B2+B3+B4+B5+B6+B7+B8+B9+B10+B11)/10) // candle 1 Long Body
         ) 
         {
           if(Display_Bearish_Match == true) 
             {
               ObjectCreate(PatternText[shift], OBJ_TEXT, 0, Time[shift1], 
                            High[shift1] + Range*1.5);
               ObjectSetText(PatternText[shift], "Match", 7, 
                             "Arial", Red);
               downArrow[shift1] = High[shift1] + Range*0.75;
             }
         }
// Bullish Match       ------------------------------------------------------------------------------------------------------
       if(
            (C1 < O1) // candle 1 bear
         && (C  <  O) // candle 0 bear
         && (C1 == C)
         && K < 25
         && D < K
         && D1 > K1
         && B1 >= 2*((B2+B3+B4+B5+B6+B7+B8+B9+B10+B11)/10) // candle 1 Long Body
         ) 
         {
           if(Display_Bullish_Match == true) 
             {   
               ObjectCreate(PatternText[shift], OBJ_TEXT, 0, Time[shift1], 
                            Low[shift1] - Range*1.5);
               ObjectSetText(PatternText[shift], "Match", 7, 
                             "Arial", Blue);
               upArrow[shift1] = Low[shift1] - Range*0.75;
             }
         }
         
// end -----------------------------------------------------------------------------------------------------------------
         }     
     } // End of for loop
   return(0);
  
//+------------------------------------------------------------------+