
#property copyright "LuboLabo 2008 - lukegeniol@gmail.com"
#property link      ""

#property indicator_separate_window

extern string ind_name = " -- STOCH_VISUAL_MTF -- by LuboLabo \xAE 2008 --";
extern string Last_bar = "--set if use last bar--";
extern bool  Last_Bar = 1;
extern string Price_Line = "--Set Price Line--";
extern int K_P = 100;
extern int D_P = 3;
extern int S_P = 3;
extern int MA_Method_P = 0;
extern int MA_Price_P = 0;
extern int Mode_P = 0;
extern string Orign_Line = "--Set Orign Line--";
extern int K_O = 14;
extern int D_O = 3;
extern int S_O = 3;
extern int MA_Method_O = 0;
extern int MA_Price_O = 0;
extern int Mode_O = 0;
extern string StochCross1 = "--Set StochCross1--";
extern int K_St1 = 14;
extern int D_St1 = 1;
extern int S_St1 = 1;
extern int MA_Method_St1 = 0;
extern int MA_Price_St1 = 0;
extern int Mode_St1 = 0;
extern string StochCross2 = "--Set StochCross2--";
extern int K_St2 = 14;
extern int D_St2 = 3;
extern int S_St2 = 3;
extern int MA_Method_St2 = 0;
extern int MA_Price_St2 = 0;
extern int Mode_St2 = 0;
extern string Filter = "--Set Filter--";
extern int K_F = 14;
extern int D_F = 3;
extern int S_F = 3;
extern int MA_Method_F = 0;
extern int MA_Price_F = 0;
extern int Mode_F = 0;
extern string Filter_M1 = "--set K D S for Filter M1--";
extern int K_F_M1 = 3;
extern int D_F_M1 = 2;
extern int S_F_M1 = 2;
extern string Color = "--Choise Colors--";
extern color color_UP = Lime;
extern color color_DOWN = Red;
extern color color_NEUTRAL = Silver;
extern color color_TEXT = Silver;
extern string position = "--Change indi window & position--";
extern bool chart_window = 0;
extern int x = 0;
extern int y = 0;

string Indicator_Name;

//______________________________________________________


int init() {
Indicator_Name =ind_name;
IndicatorShortName(Indicator_Name);

   return (0);
}
//______________________________________________________

int deinit()
 {
   ObjectDelete("COMB_M1");
   ObjectDelete("COMB_M5");
   ObjectDelete("COMB_M15");
   ObjectDelete("COMB_H1");
   ObjectDelete("COMB_H1");
   ObjectDelete("COMB_H4");
   ObjectDelete("Price_Line_TEXT");
   ObjectDelete("Price_LineM1");
   ObjectDelete("Price_LineM5");
   ObjectDelete("Price_LineM15");
   ObjectDelete("Price_LineM30");
   ObjectDelete("Price_LineH1");
   ObjectDelete("Price_LineH4");
   ObjectDelete("Origin_Line_TEXT");
   ObjectDelete("Origin_LineM1");
   ObjectDelete("Origin_LineM5");
   ObjectDelete("Origin_LineM15");
   ObjectDelete("Origin_LineM30");
   ObjectDelete("Origin_LineH1");
   ObjectDelete("Origin_LineH4");
   ObjectDelete("Stoch_Cross_TEXT");
   ObjectDelete("Stoch_CrossM1");
   ObjectDelete("Stoch_CrossM5");
   ObjectDelete("Stoch_CrossM15");
   ObjectDelete("Stoch_CrossM30");
   ObjectDelete("Stoch_CrossH1");
   ObjectDelete("Stoch_CrossH4");
   ObjectDelete("Filter_TEXT");
   ObjectDelete("FilterM1");
   ObjectDelete("FilterM5");
   ObjectDelete("FilterM15");
   ObjectDelete("FilterM30");
   ObjectDelete("FilterH1");
   ObjectDelete("FilterH4");
   
   return (0);
}
//______________________________________________________


int start() {
   color color_P1;
   color color_P2;
   color color_P3;
   color color_P4;
   color color_P5;
   color color_P6;
   color color_O1;
   color color_O2;
   color color_O3;
   color color_O4;
   color color_O5;
   color color_O6;
   color color_F1;
   color color_F2;
   color color_F3;
   color color_F4;
   color color_F5;
   color color_F6;
   color color_ST11;
   color color_ST12;
   color color_ST13;
   color color_ST14;
   color color_ST15;
   color color_ST16;
    
   int a1, b1, c1, d1, e1, f1, g1, h1; 
   int a2, b2, c2, d2, e2, f2, g2, h2;
   int a3, b3, c3, d3, e3, f3, g3, h3;
   int a4, b4, c4, d4, e4, f4, g4, h4;
   int a5, b5, c5, d5, e5, f5, g5, h5;
   int a6, b6, c6, d6, e6, f6, g6, h6;
   
   int window = WindowFind(Indicator_Name);
   
   if (chart_window) window = 0;
   
   if (y < 0) return (0);
  
   int i = 1;
   if (Last_Bar) i = 0;
   
   double Price_prev1 = iStochastic(NULL, PERIOD_M1, K_P, D_P, S_P, MA_Method_P,MA_Price_P, Mode_P, i+1);
   double Price_prev2 = iStochastic(NULL, PERIOD_M5, K_P, D_P, S_P, MA_Method_P,MA_Price_P, Mode_P, i+1);
   double Price_prev3 = iStochastic(NULL, PERIOD_M15, K_P, D_P, S_P, MA_Method_P,MA_Price_P, Mode_P, i+1);
   double Price_prev4 = iStochastic(NULL, PERIOD_M30, K_P, D_P, S_P, MA_Method_P,MA_Price_P, Mode_P, i+1);
   double Price_prev5 = iStochastic(NULL, PERIOD_H1, K_P, D_P, S_P, MA_Method_P,MA_Price_P, Mode_P, i+1);
   double Price_prev6 = iStochastic(NULL, PERIOD_H4, K_P, D_P, S_P, MA_Method_P,MA_Price_P, Mode_P, i+1);   

   double Price_Line1 = iStochastic(NULL, PERIOD_M1, K_P, D_P, S_P, MA_Method_P,MA_Price_P, Mode_P, i);
   double Price_Line2 = iStochastic(NULL, PERIOD_M5, K_P, D_P, S_P, MA_Method_P,MA_Price_P, Mode_P, i);
   double Price_Line3 = iStochastic(NULL, PERIOD_M15, K_P, D_P, S_P, MA_Method_P,MA_Price_P, Mode_P, i);
   double Price_Line4 = iStochastic(NULL, PERIOD_M30, K_P, D_P, S_P, MA_Method_P,MA_Price_P, Mode_P, i);
   double Price_Line5 = iStochastic(NULL, PERIOD_H1, K_P, D_P, S_P, MA_Method_P,MA_Price_P, Mode_P, i);
   double Price_Line6 = iStochastic(NULL, PERIOD_H4, K_P, D_P, S_P, MA_Method_P,MA_Price_P, Mode_P, i);
   
   double Origin_prev1 = iStochastic(NULL, PERIOD_M1, K_O, D_O, S_O, MA_Method_O,MA_Price_O, Mode_O, i+1);
   double Origin_prev2 = iStochastic(NULL, PERIOD_M5, K_O, D_O, S_O, MA_Method_O,MA_Price_O, Mode_O, i+1);
   double Origin_prev3 = iStochastic(NULL, PERIOD_M15, K_O, D_O, S_O, MA_Method_O,MA_Price_O, Mode_O, i+1);
   double Origin_prev4 = iStochastic(NULL, PERIOD_M30, K_O, D_O, S_O, MA_Method_O,MA_Price_O, Mode_O, i+1);
   double Origin_prev5 = iStochastic(NULL, PERIOD_H1, K_O, D_O, S_O, MA_Method_O,MA_Price_O, Mode_O, i+1);
   double Origin_prev6 = iStochastic(NULL, PERIOD_H4, K_O, D_O, S_O, MA_Method_O,MA_Price_O, Mode_O, i+1);
   
   double Origin_Line1 = iStochastic(NULL, PERIOD_M1, K_O, D_O, S_O, MA_Method_O,MA_Price_O, Mode_O, i);
   double Origin_Line2 = iStochastic(NULL, PERIOD_M5, K_O, D_O, S_O, MA_Method_O,MA_Price_O, Mode_O, i);
   double Origin_Line3 = iStochastic(NULL, PERIOD_M15, K_O, D_O, S_O, MA_Method_O,MA_Price_O, Mode_O, i);
   double Origin_Line4 = iStochastic(NULL, PERIOD_M30, K_O, D_O, S_O, MA_Method_O,MA_Price_O, Mode_O, i);
   double Origin_Line5 = iStochastic(NULL, PERIOD_H1, K_O, D_O, S_O, MA_Method_O,MA_Price_O, Mode_O, i);
   double Origin_Line6 = iStochastic(NULL, PERIOD_H4, K_O, D_O, S_O, MA_Method_O,MA_Price_O, Mode_O, i);
   
   double StochCross1_prev1 = iStochastic(NULL, PERIOD_M1, K_St1, D_St1, S_St1, MA_Method_St1,MA_Price_St1, Mode_St1, i+1);
   double StochCross1_prev2 = iStochastic(NULL, PERIOD_M5, K_St1, D_St1, S_St1, MA_Method_St1,MA_Price_St1, Mode_St1, i+1);
   double StochCross1_prev3 = iStochastic(NULL, PERIOD_M15, K_St1, D_St1, S_St1, MA_Method_St1,MA_Price_St1, Mode_St1, i+1);
   double StochCross1_prev4 = iStochastic(NULL, PERIOD_M30, K_St1, D_St1, S_St1, MA_Method_St1,MA_Price_St1, Mode_St1, i+1);
   double StochCross1_prev5 = iStochastic(NULL, PERIOD_H1, K_St1, D_St1, S_St1, MA_Method_St1,MA_Price_St1, Mode_St1, i+1);
   double StochCross1_prev6 = iStochastic(NULL, PERIOD_H4, K_St1, D_St1, S_St1, MA_Method_St1,MA_Price_St1, Mode_St1, i+1);
   
   double StochCross1_Line1 = iStochastic(NULL, PERIOD_M1, K_St1, D_St1, S_St1, MA_Method_St1,MA_Price_St1, Mode_St1, i);
   double StochCross1_Line2 = iStochastic(NULL, PERIOD_M5, K_St1, D_St1, S_St1, MA_Method_St1,MA_Price_St1, Mode_St1, i);
   double StochCross1_Line3 = iStochastic(NULL, PERIOD_M15, K_St1, D_St1, S_St1, MA_Method_St1,MA_Price_St1, Mode_St1, i);
   double StochCross1_Line4 = iStochastic(NULL, PERIOD_M30, K_St1, D_St1, S_St1, MA_Method_St1,MA_Price_St1, Mode_St1, i);
   double StochCross1_Line5 = iStochastic(NULL, PERIOD_H1, K_St1, D_St1, S_St1, MA_Method_St1,MA_Price_St1, Mode_St1, i);
   double StochCross1_Line6 = iStochastic(NULL, PERIOD_H4, K_St1, D_St1, S_St1, MA_Method_St1,MA_Price_St1, Mode_St1, i);
   
   double StochCross2_Line1 = iStochastic(NULL, PERIOD_M5, K_St2, D_St2, S_St2, MA_Method_St2,MA_Price_St2, Mode_St2, i);
   double StochCross2_Line2 = iStochastic(NULL, PERIOD_M15, K_St2, D_St2, S_St2, MA_Method_St2,MA_Price_St2, Mode_St2, i);
   double StochCross2_Line3 = iStochastic(NULL, PERIOD_M30, K_St2, D_St2, S_St2, MA_Method_St2,MA_Price_St2, Mode_St2, i);
   double StochCross2_Line4 = iStochastic(NULL, PERIOD_H1, K_St2, D_St2, S_St2, MA_Method_St2,MA_Price_St2, Mode_St2, i);
   double StochCross2_Line5 = iStochastic(NULL, PERIOD_H4, K_St2, D_St2, S_St2, MA_Method_St2,MA_Price_St2, Mode_St2, i);
   double StochCross2_Line6 = iStochastic(NULL, PERIOD_D1, K_St2, D_St2, S_St2, MA_Method_St2,MA_Price_St2, Mode_St2, i);
   
   double Filter_line1 = iStochastic(NULL, PERIOD_M1, K_F_M1, D_F_M1, S_F_M1, MA_Method_F,MA_Price_F, Mode_F, i);
   double Filter_line2 = iStochastic(NULL, PERIOD_M1, K_F, D_F, S_F, MA_Method_F,MA_Price_F, Mode_F, i);
   double Filter_line3 = iStochastic(NULL, PERIOD_M5, K_F, D_F, S_F, MA_Method_F,MA_Price_F, Mode_F, i);
   double Filter_line4 = iStochastic(NULL, PERIOD_M15, K_F, D_F, S_F, MA_Method_F,MA_Price_F, Mode_F, i);
   double Filter_line5 = iStochastic(NULL, PERIOD_M30, K_F, D_F, S_F, MA_Method_F,MA_Price_F, Mode_F, i);
   double Filter_line6 = iStochastic(NULL, PERIOD_H1, K_F, D_F, S_F, MA_Method_F,MA_Price_F, Mode_F, i);
   
   
   //--COMB 1 
  
   a1 = (Price_Line1 <= 23.6 && Price_prev1 < Price_Line1);
       
   b1 = (Price_Line1 >= 76.4 && Price_prev1 > Price_Line1); 
        
   if (a1 == true)  color_P1 = color_UP;   if (b1 == true) color_P1 = color_DOWN;     
   if (!a1 && !b1) color_P1 = color_NEUTRAL; 
       
   c1 = ((Origin_Line1 >= 23.6) && (Origin_prev1 < Origin_Line1));
        
   d1 = ((Origin_Line1 <= 76.4) && (Origin_prev1 > Origin_Line1));
        
   if (c1 == true) color_O1 = color_UP;   if (d1 == true) color_O1 = color_DOWN;        
   if (!c1 && !d1)color_O1 = color_NEUTRAL;  
 
   e1 = (StochCross1_Line1 > 20 && StochCross1_Line1 > StochCross2_Line1 && StochCross1_prev1 < StochCross1_Line1); 
         
   f1 = (StochCross1_Line1 < 80 && StochCross1_Line1 < StochCross2_Line1 && StochCross1_prev1 > StochCross1_Line1);     
       
   if (e1 == true) color_ST11 = color_UP; if (f1 == true) color_ST11 = color_DOWN;    
   if (!e1 && !f1) color_ST11 = color_NEUTRAL;
   
   g1 = (Filter_line1 > 76.4); 
                
   h1 = (Filter_line1 < 23.6); 
        
   if (g1 == true) color_F1 = color_UP; if (h1 == true) color_F1 = color_DOWN;       
   if (!g1 && !h1) color_F1 = color_NEUTRAL;


  //--COMB 2 
  
   a2 = (Price_Line2 <= 23.6 && Price_prev2 < Price_Line2);
       
   b2 = (Price_Line2 >= 76.4 && Price_prev2 > Price_Line2); 
        
   if (a2 == true)  color_P2 = color_UP;   if (b2 == true) color_P2 = color_DOWN;     
   if (!a2 && !b2) color_P2 = color_NEUTRAL; 
       
   c2 = ((Origin_Line2 >= 23.6) && (Origin_prev2 < Origin_Line2));
        
   d2 = ((Origin_Line2 <= 76.4) && (Origin_prev2 > Origin_Line2));
        
   if (c2 == true) color_O2 = color_UP;   if (d2 == true) color_O2 = color_DOWN;        
   if (!c2 && !d2) color_O2 = color_NEUTRAL;  
 
   e2 = (StochCross1_Line2 > 20 && StochCross1_Line2 > StochCross2_Line2 && StochCross1_prev2 < StochCross1_Line2); 
         
   f2 = (StochCross1_Line2 < 80 && StochCross1_Line2 < StochCross2_Line2 && StochCross1_prev2 > StochCross1_Line2);     
       
   if (e2 == true) color_ST12 = color_UP; if (f2 == true) color_ST12 = color_DOWN;    
   if (!e2 && !f2) color_ST12 = color_NEUTRAL;
   
   g2 = (Filter_line2 > 76.4); 
                
   h2 = (Filter_line2 < 23.6); 
        
   if (g2 == true) color_F2 = color_UP; if (h2 == true) color_F2 = color_DOWN;       
   if (!g2 && !h2) color_F2 = color_NEUTRAL;
   
  
   //--COMB 3  
   
   a3 = (Price_Line3 <= 23.6 && Price_prev3 < Price_Line3);
       
   b3 = (Price_Line3 >= 76.4 && Price_prev3 > Price_Line3); 
        
   if (a3 == true)  color_P3 = color_UP;   if (b3 == true) color_P3 = color_DOWN;     
   if (!a3 && !b3) color_P3 = color_NEUTRAL; 
       
   c3 = ((Origin_Line3 >= 23.6) && (Origin_prev3 < Origin_Line3));
        
   d3 = ((Origin_Line3 <= 76.4) && (Origin_prev3 > Origin_Line3));
        
   if (c3 == true) color_O3 = color_UP;   if (d3 == true) color_O3 = color_DOWN;        
   if (!c3 && !d3) color_O3 = color_NEUTRAL;  
 
   e3 = (StochCross1_Line3 > 20 && StochCross1_Line3 > StochCross2_Line3 && StochCross1_prev3 < StochCross1_Line3); 
         
   f3 = (StochCross1_Line3 < 80 && StochCross1_Line3 < StochCross2_Line2 && StochCross1_prev3 > StochCross1_Line3);     
       
   if (e3 == true) color_ST13 = color_UP; if (f3 == true) color_ST13 = color_DOWN;    
   if (!e3 && !f3) color_ST13 = color_NEUTRAL;
   
   g3 = (Filter_line3 > 76.4); 
                
   h3 = (Filter_line3 < 23.6); 
        
   if (g3 == true) color_F3 = color_UP; if (h3 == true) color_F3 = color_DOWN;       
   if (!g3 && !h3) color_F3 = color_NEUTRAL;
   
   
   //--COMB 4   
   
   a4 = (Price_Line4 <= 23.6 && Price_prev4 < Price_Line4);
       
   b4 = (Price_Line4 >= 76.4 && Price_prev4 > Price_Line4); 
        
   if (a4 == true)  color_P4 = color_UP;   if (b4 == true) color_P4 = color_DOWN;     
   if (!a4 && !b4) color_P4 = color_NEUTRAL; 
       
   c4 = ((Origin_Line4 >= 23.6) && (Origin_prev4 < Origin_Line4));
        
   d4 = ((Origin_Line4 <= 76.4) && (Origin_prev4 > Origin_Line4));
        
   if (c4 == true) color_O4 = color_UP;   if (d4 == true) color_O4 = color_DOWN;        
   if (!c4 && !d4) color_O4 = color_NEUTRAL;  
 
   e4 = (StochCross1_Line4 > 20 && StochCross1_Line4 > StochCross2_Line4 && StochCross1_prev4 < StochCross1_Line4); 
         
   f4 = (StochCross1_Line4 < 80 && StochCross1_Line4 < StochCross2_Line4 && StochCross1_prev4 > StochCross1_Line4);     
       
   if (e4 == true) color_ST14 = color_UP; if (f4 == true) color_ST14 = color_DOWN;    
   if (!e4 && !f4) color_ST14 = color_NEUTRAL;
   
   g4 = (Filter_line4 > 76.4); 
                
   h4 = (Filter_line4 < 23.6); 
        
   if (g4 == true) color_F4 = color_UP; if (h4 == true) color_F4 = color_DOWN;       
   if (!g4 && !h4) color_F4 = color_NEUTRAL;
   
   
   //--COMB 5   
   
   a5 = (Price_Line5 <= 23.6 && Price_prev5 < Price_Line5);
       
   b5 = (Price_Line5 >= 76.4 && Price_prev5 > Price_Line5); 
        
   if (a5 == true)  color_P5 = color_UP;   if (b5 == true) color_P5 = color_DOWN;     
   if (!a5 && !b5) color_P5 = color_NEUTRAL; 
       
   c5 = ((Origin_Line5 >= 23.6) && (Origin_prev5 < Origin_Line5));
        
   d5 = ((Origin_Line5 <= 76.4) && (Origin_prev5 > Origin_Line5));
        
   if (c5 == true) color_O5 = color_UP;   if (d5 == true) color_O5 = color_DOWN;        
   if (!c5 && !d5) color_O5 = color_NEUTRAL;  
 
   e5 = (StochCross1_Line5 > 20 && StochCross1_Line5 > StochCross2_Line5 && StochCross1_prev5 < StochCross1_Line5); 
         
   f5 = (StochCross1_Line5 < 80 && StochCross1_Line5 < StochCross2_Line5 && StochCross1_prev5 > StochCross1_Line5);     
       
   if (e5 == true) color_ST15 = color_UP; if (f5 == true) color_ST15 = color_DOWN;    
   if (!e5 && !f5) color_ST15 = color_NEUTRAL;
   
   g5 = (Filter_line5 > 76.4); 
                
   h5 = (Filter_line5 < 23.6); 
        
   if (g5 == true) color_F5 = color_UP; if (h5 == true) color_F5 = color_DOWN;       
   if (!g5 && !h5) color_F5 = color_NEUTRAL;
   
   
   
   //--COMB 6   
   
   a6 = (Price_Line6 <= 23.6 && Price_prev6 < Price_Line6);
       
   b6 = (Price_Line6 >= 76.4 && Price_prev6 > Price_Line6); 
        
   if (a6 == true)  color_P6 = color_UP;   if (b6 == true) color_P6 = color_DOWN;     
   if (!a6 && !b6) color_P6 = color_NEUTRAL; 
       
   c6 = ((Origin_Line6 >= 23.6) && (Origin_prev6 < Origin_Line6));
        
   d6 = ((Origin_Line6 <= 76.4) && (Origin_prev6 > Origin_Line6));
        
   if (c6 == true) color_O6 = color_UP;   if (d6 == true) color_O6 = color_DOWN;        
   if (!c6 && !d6) color_O6 = color_NEUTRAL;  
 
   e6 = (StochCross1_Line6 > 20 && StochCross1_Line6 > StochCross2_Line6 && StochCross1_prev6 < StochCross1_Line6); 
         
   f6 = (StochCross1_Line6 < 80 && StochCross1_Line6 < StochCross2_Line6 && StochCross1_prev6 > StochCross1_Line6);     
       
   if (e6 == true) color_ST16 = color_UP; if (f6 == true) color_ST16 = color_DOWN;    
   if (!e6 && !f6) color_ST16 = color_NEUTRAL;
   
   g6 = (Filter_line6 > 76.4); 
                
   h6 = (Filter_line6 < 23.6); 
        
   if (g6 == true) color_F6 = color_UP; if (h6 == true) color_F6 = color_DOWN;       
   if (!g6 && !h6) color_F6 = color_NEUTRAL;
   
   
       
   ObjectDelete("COMB_M1");
   ObjectCreate("COMB_M1", OBJ_LABEL, window, 0, 0);
   ObjectSetText("COMB_M1", "M1", 8, "Comic Sans MS", color_TEXT);
   ObjectSet("COMB_M1", OBJPROP_XDISTANCE, x + 60);
   ObjectSet("COMB_M1", OBJPROP_YDISTANCE, y + 34);
   ObjectDelete("COMB_M5");
   ObjectCreate("COMB_M5", OBJ_LABEL, window, 0, 0);
   ObjectSetText("COMB_M5", "M5", 8, "Comic Sans MS", color_TEXT);
   ObjectSet("COMB_M5", OBJPROP_XDISTANCE, x + 86);
   ObjectSet("COMB_M5", OBJPROP_YDISTANCE, y + 34);
   ObjectDelete("COMB_M15");
   ObjectCreate("COMB_M15", OBJ_LABEL, window, 0, 0);
   ObjectSetText("COMB_M15", "M15", 8, "Comic Sans MS", color_TEXT);
   ObjectSet("COMB_M15", OBJPROP_XDISTANCE, x + 112);
   ObjectSet("COMB_M15", OBJPROP_YDISTANCE, y + 34);
   ObjectDelete("COMB_M30");
   ObjectCreate("COMB_M30", OBJ_LABEL, window, 0, 0);
   ObjectSetText("COMB_M30", "M30", 8, "Comic Sans MS", color_TEXT);
   ObjectSet("COMB_M30", OBJPROP_XDISTANCE, x + 140);
   ObjectSet("COMB_M30", OBJPROP_YDISTANCE, y + 34);
   ObjectDelete("COMB_H1");
   ObjectCreate("COMB_H1", OBJ_LABEL, window, 0, 0);
   ObjectSetText("COMB_H1", "H1", 8, "Comic Sans MS", color_TEXT);
   ObjectSet("COMB_H1", OBJPROP_XDISTANCE, x + 172);
   ObjectSet("COMB_H1", OBJPROP_YDISTANCE, y + 34);
   ObjectDelete("COMB_H4");
   ObjectCreate("COMB_H4", OBJ_LABEL, window, 0, 0);
   ObjectSetText("COMB_H4", "H4", 8, "Comic Sans MS", color_TEXT);
   ObjectSet("COMB_H4", OBJPROP_XDISTANCE, x + 198);
   ObjectSet("COMB_H4", OBJPROP_YDISTANCE, y + 34);
   
   
   ObjectDelete("Price_Line_TEXT");
   ObjectCreate("Price_Line_TEXT", OBJ_LABEL, window, 0, 0);
   ObjectSetText("Price_Line_TEXT", "PRICE", 8, "Comic Sans MS", color_TEXT);   
   ObjectSet("Price_Line_TEXT", OBJPROP_XDISTANCE, x + 15);
   ObjectSet("Price_Line_TEXT", OBJPROP_YDISTANCE, y + 50);
   ObjectDelete("Price_LineM1");
   ObjectCreate("Price_LineM1", OBJ_LABEL, window, 0, 0);
   ObjectSetText("Price_LineM1","-", 64, "Impact", color_P1);   
   ObjectSet("Price_LineM1", OBJPROP_XDISTANCE, x + 54);
   ObjectSet("Price_LineM1", OBJPROP_YDISTANCE, y);
   ObjectDelete("Price_LineM5");
   ObjectCreate("Price_LineM5", OBJ_LABEL, window, 0, 0);
   ObjectSetText("Price_LineM5","-", 64, "Impact", color_P2);   
   ObjectSet("Price_LineM5", OBJPROP_XDISTANCE, x + 82);
   ObjectSet("Price_LineM5", OBJPROP_YDISTANCE, y);
   ObjectDelete("Price_LineM15");
   ObjectCreate("Price_LineM15", OBJ_LABEL, window, 0, 0);
   ObjectSetText("Price_LineM15", "-", 64, "Impact", color_P3);  
   ObjectSet("Price_LineM15", OBJPROP_XDISTANCE, x + 110);
   ObjectSet("Price_LineM15", OBJPROP_YDISTANCE, y );
   ObjectDelete("Price_LineM30");
   ObjectCreate("Price_LineM30", OBJ_LABEL, window, 0, 0);
   ObjectSetText("Price_LineM30", "-", 64, "Impact", color_P4);  
   ObjectSet("Price_LineM30", OBJPROP_XDISTANCE, x + 138);
   ObjectSet("Price_LineM30", OBJPROP_YDISTANCE, y );
   ObjectDelete("Price_LineH1");
   ObjectCreate("Price_LineH1", OBJ_LABEL, window, 0, 0);
   ObjectSetText("Price_LineH1", "-", 64, "Impact", color_P5);   
   ObjectSet("Price_LineH1", OBJPROP_XDISTANCE, x + 166);
   ObjectSet("Price_LineH1", OBJPROP_YDISTANCE, y );
   ObjectCreate("Price_LineH4", OBJ_LABEL, window, 0, 0);
   ObjectSetText("Price_LineH4", "-", 64, "Impact", color_P6);   
   ObjectSet("Price_LineH4", OBJPROP_XDISTANCE, x + 194);
   ObjectSet("Price_LineH4", OBJPROP_YDISTANCE, y );
   
   ObjectDelete("Origin_Line_TEXT");
   ObjectCreate("Origin_Line_TEXT", OBJ_LABEL, window, 0, 0);
   ObjectSetText("Origin_Line_TEXT", "ORIGIN", 8, "Comic Sans MS", color_TEXT);   
   ObjectSet("Origin_Line_TEXT", OBJPROP_XDISTANCE, x + 15);
   ObjectSet("Origin_Line_TEXT", OBJPROP_YDISTANCE, y + 65);
   ObjectDelete("Origin_LineM1");
   ObjectCreate("Origin_LineM1", OBJ_LABEL, window, 0, 0);
   ObjectSetText("Origin_LineM1", "-", 64, "Impact", color_O1);   
   ObjectSet("Origin_LineM1", OBJPROP_XDISTANCE, x + 54);
   ObjectSet("Origin_LineM1", OBJPROP_YDISTANCE, y + 15);
   ObjectDelete("Origin_LineM5");
   ObjectCreate("Origin_LineM5", OBJ_LABEL, window, 0, 0);
   ObjectSetText("Origin_LineM5", "-", 64, "Impact", color_O2);   
   ObjectSet("Origin_LineM5", OBJPROP_XDISTANCE, x + 82);
   ObjectSet("Origin_LineM5", OBJPROP_YDISTANCE, y + 15);
   ObjectDelete("Origin_LineM15");
   ObjectCreate("Origin_LineM15", OBJ_LABEL, window, 0, 0);
   ObjectSetText("Origin_LineM15", "-", 64, "Impact", color_O3);   
   ObjectSet("Origin_LineM15", OBJPROP_XDISTANCE, x + 110);
   ObjectSet("Origin_LineM15", OBJPROP_YDISTANCE, y + 15);
   ObjectDelete("Origin_LineM30");
   ObjectCreate("Origin_LineM30", OBJ_LABEL, window, 0, 0);
   ObjectSetText("Origin_LineM30", "-", 64, "Impact", color_O4);   
   ObjectSet("Origin_LineM30", OBJPROP_XDISTANCE, x + 138);
   ObjectSet("Origin_LineM30", OBJPROP_YDISTANCE, y + 15);
   ObjectDelete("Origin_LineH1");
   ObjectCreate("Origin_LineH1", OBJ_LABEL, window, 0, 0);
   ObjectSetText("Origin_LineH1", "-", 64, "Impact", color_O5);   
   ObjectSet("Origin_LineH1", OBJPROP_XDISTANCE, x + 166);
   ObjectSet("Origin_LineH1", OBJPROP_YDISTANCE, y + 15);
   ObjectDelete("Origin_LineH4");
   ObjectCreate("Origin_LineH4", OBJ_LABEL, window, 0, 0);
   ObjectSetText("Origin_LineH4", "-", 64, "Impact", color_O6);   
   ObjectSet("Origin_LineH4", OBJPROP_XDISTANCE, x + 194);
   ObjectSet("Origin_LineH4", OBJPROP_YDISTANCE, y + 15);
  

   ObjectDelete("Stoch_Cross_TEXT");
   ObjectCreate("Stoch_Cross_TEXT", OBJ_LABEL, window, 0, 0);
   ObjectSetText("Stoch_Cross_TEXT", "CROSS", 8, "Comic Sans MS", color_TEXT);   
   ObjectSet("Stoch_Cross_TEXT", OBJPROP_XDISTANCE, x + 15);
   ObjectSet("Stoch_Cross_TEXT", OBJPROP_YDISTANCE, y + 80);
   ObjectDelete("Stoch_CrossM1");
   ObjectCreate("Stoch_CrossM1", OBJ_LABEL, window, 0, 0);
   ObjectSetText("Stoch_CrossM1", "-", 64, "Impact", color_ST11);   
   ObjectSet("Stoch_CrossM1", OBJPROP_XDISTANCE, x + 54);
   ObjectSet("Stoch_CrossM1", OBJPROP_YDISTANCE, y + 30);
   ObjectDelete("Stoch_CrossM5");
   ObjectCreate("Stoch_CrossM5", OBJ_LABEL, window, 0, 0);
   ObjectSetText("Stoch_CrossM5", "-", 64, "Impact", color_ST12);   
   ObjectSet("Stoch_CrossM5", OBJPROP_XDISTANCE, x + 82);
   ObjectSet("Stoch_CrossM5", OBJPROP_YDISTANCE, y + 30);
   ObjectDelete("Stoch_CrossM15");
   ObjectCreate("Stoch_CrossM15", OBJ_LABEL, window, 0, 0);
   ObjectSetText("Stoch_CrossM15", "-", 64, "Impact", color_ST13);  
   ObjectSet("Stoch_CrossM15", OBJPROP_XDISTANCE, x + 110);
   ObjectSet("Stoch_CrossM15", OBJPROP_YDISTANCE, y + 30);
   ObjectDelete("Stoch_CrossM30");
   ObjectCreate("Stoch_CrossM30", OBJ_LABEL, window, 0, 0);
   ObjectSetText("Stoch_CrossM30", "-", 64, "Impact", color_ST14);   
   ObjectSet("Stoch_CrossM30", OBJPROP_XDISTANCE, x + 138);
   ObjectSet("Stoch_CrossM30", OBJPROP_YDISTANCE, y + 30);
   ObjectDelete("Stoch_CrossH1");
   ObjectCreate("Stoch_CrossH1", OBJ_LABEL, window, 0, 0);
   ObjectSetText("Stoch_CrossH1", "-", 64, "Impact", color_ST15);   
   ObjectSet("Stoch_CrossH1", OBJPROP_XDISTANCE, x + 166);
   ObjectSet("Stoch_CrossH1", OBJPROP_YDISTANCE, y + 30);
   ObjectDelete("Stoch_CrossH4");
   ObjectCreate("Stoch_CrossH4", OBJ_LABEL, window, 0, 0);
   ObjectSetText("Stoch_CrossH4", "-", 64, "Impact", color_ST16);   
   ObjectSet("Stoch_CrossH4", OBJPROP_XDISTANCE, x + 194);
   ObjectSet("Stoch_CrossH4", OBJPROP_YDISTANCE, y + 30);
   
   
   ObjectDelete("Filter_TEXT");
   ObjectCreate("Filter_TEXT", OBJ_LABEL, window, 0, 0);
   ObjectSetText("Filter_TEXT", "FILTER", 8, "Comic Sans MS", color_TEXT);   
   ObjectSet("Filter_TEXT", OBJPROP_XDISTANCE, x + 15);
   ObjectSet("Filter_TEXT", OBJPROP_YDISTANCE, y + 95);
   ObjectDelete("FilterM1");
   ObjectCreate("FilterM1", OBJ_LABEL, window, 0, 0);
   ObjectSetText("FilterM1", "-", 64, "Impact", color_F1);   
   ObjectSet("FilterM1", OBJPROP_XDISTANCE, x + 54);
   ObjectSet("FilterM1", OBJPROP_YDISTANCE, y + 45);
   ObjectDelete("FilterM5");
   ObjectCreate("FilterM5", OBJ_LABEL, window, 0, 0);
   ObjectSetText("FilterM5", "-", 64, "Impact", color_F2);   
   ObjectSet("FilterM5", OBJPROP_XDISTANCE, x + 82);
   ObjectSet("FilterM5", OBJPROP_YDISTANCE, y + 45);
   ObjectDelete("FilterM15");
   ObjectCreate("FilterM15", OBJ_LABEL, window, 0, 0);
   ObjectSetText("FilterM15", "-", 64, "Impact", color_F3);   
   ObjectSet("FilterM15", OBJPROP_XDISTANCE, x + 110);
   ObjectSet("FilterM15", OBJPROP_YDISTANCE, y + 45);
   ObjectDelete("FilterM30");
   ObjectCreate("FilterM30", OBJ_LABEL, window, 0, 0);
   ObjectSetText("FilterM30", "-", 64, "Impact", color_F4);   
   ObjectSet("FilterM30", OBJPROP_XDISTANCE, x + 138);
   ObjectSet("FilterM30", OBJPROP_YDISTANCE, y + 45);
   ObjectDelete("FilterH1");
   ObjectCreate("FilterH1", OBJ_LABEL, window, 0, 0);
   ObjectSetText("FilterH1", "-", 64, "Impact", color_F5);   
   ObjectSet("FilterH1", OBJPROP_XDISTANCE, x + 166);
   ObjectSet("FilterH1", OBJPROP_YDISTANCE, y + 45);
   ObjectDelete("FilterH4");
   ObjectCreate("FilterH4", OBJ_LABEL, window, 0, 0);
   ObjectSetText("FilterH4", "-", 64, "Impact", color_F6); 
   ObjectSet("FilterH4", OBJPROP_XDISTANCE, x + 194);
   ObjectSet("FilterH4", OBJPROP_YDISTANCE, y + 45);
 
   return (0);

}