//+------------------------------------------------------------------+
//|                                                     STOH_RSI.mq4 |
//|                                                           AVMOHR |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "AVMOHR"
#property link      ""
#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 100
#property indicator_level1 20
#property indicator_level2 30
#property indicator_level3 50
#property indicator_level4 70
#property indicator_level5 80
#property indicator_buffers 3
#property indicator_color1 LightSeaGreen
#property indicator_color2 Red
#property indicator_color3 DodgerBlue
//+------------------------------------------------------------------+
extern string rem1="  ";
extern int KPeriod=5;
extern int DPeriod=3;
extern int Slowing=3;
extern string rem2="   ";
extern string rem3="0 - MODE_SMA; 1 - MODE_EMA, 2 - MODE_SMMA, 3 - MODE_LWMA";
extern int method=0;
extern string rem4="  : 0 - Low/High  1 - Close/Close";
extern int price_field=0;
extern string rem5=" RSI";
extern int RSIPeriod=14;
extern string rem6="0-PRICE_CLOSE; 1-PRICE_OPEN; 2-PRICE_HIGH; 3-PRICE_LOW; 4-PRICE_MEDIAN; 5-PRICE_TYPICAL; 6-PRICE_WEIGHTED";
extern int applied_price=0;
extern int History=5000;
double Buf_0[];
double Buf_1[];
double Buf_2[];
int   i=0;
//+------------------------------------------------------------------+
int init()
  {
  int Counted_bars;                       //    
  Counted_bars=IndicatorCounted();        //       
  i=Bars-Counted_bars;                    //      
  if (i>History-1)                        //     ..      
    i=History-1;                          // ..  .

//---- indicators
SetIndexBuffer(0,Buf_0);                    //      
SetIndexStyle (0,DRAW_LINE,STYLE_SOLID,1);  //      

SetIndexBuffer(1,Buf_1);                    //             
SetIndexStyle (1,DRAW_LINE,STYLE_DOT,1);   //    

SetIndexBuffer(2,Buf_2);                    //      
SetIndexStyle (2,DRAW_LINE,STYLE_SOLID,1);  //    

string short_name="StoH("+KPeriod+","+DPeriod+","+Slowing+"); RSI("+RSIPeriod+")";
IndicatorShortName(short_name);

SetIndexLabel(0,"Stoh_Main");
SetIndexLabel(1,"Stoh_Signal");
SetIndexLabel(3,"RSI");
   
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
//----
   while(i>=0)                            //         
    { 
    Buf_0[i]=iStochastic(NULL,0,KPeriod,DPeriod,Slowing,method,price_field,MODE_MAIN,i);
    Buf_1[i]=iStochastic(NULL,0,KPeriod,DPeriod,Slowing,method,price_field,MODE_SIGNAL,i);
    Buf_2[i]=iRSI(NULL,0,RSIPeriod,applied_price,i);
    
    i--;                            //         
    }
//----
   return(0);
  }
//+------------------------------------------------------------------+