//+------------------------------------------------------------------+
//|                                               Stochastic osma.mq4|
//|                                                  Copyright  2008|
//+------------------------------------------------------------------+
//2008fxtsd    ki

#property copyright ""
#property link      ""

#property indicator_separate_window

#property indicator_buffers 4
#property indicator_color1 Blue
#property indicator_color2 Red
#property indicator_color3 Green
#property indicator_color4 Red



#property indicator_level1 80
#property indicator_level2 50
#property indicator_level3 20
#property indicator_levelcolor DarkSlateGray


//---- 


extern int KPeriod=8;
extern int DPeriod=3;
extern int Slowing=3;
extern int MAMethod=0;
extern int PriceField=1;


extern string PriceField_  = "0=Hi/Low   1=Close/Close";
extern string MA_Method_   = "SMA0 EMA1 SMMA2 LWMA3";


double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];





//+----------------

int init()
  {
   
  
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle (0,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexStyle (1,DRAW_LINE);

   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexStyle (2,DRAW_HISTOGRAM);

   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexStyle (3,DRAW_HISTOGRAM);

 
   IndicatorShortName("Stochastic ("+KPeriod+","+DPeriod+","+Slowing+") Osma ");  
  }

   return(0);
 




//+---------------------

int start()
{
   int i,limit,counted_bars=IndicatorCounted();
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   
      limit=Bars-counted_bars;


 
   for(i=limit; i>=0; i--)
  
      {
      ExtMapBuffer1[i] = iStochastic(NULL,0,KPeriod,DPeriod,Slowing,MAMethod,PriceField,MODE_MAIN,i);

      ExtMapBuffer2[i] = iStochastic(NULL,0,KPeriod,DPeriod,Slowing,MAMethod,PriceField,MODE_SIGNAL,i);
   
      
      double StoOsma = (ExtMapBuffer1[i]-ExtMapBuffer2[i]);
      
      
      
                         ExtMapBuffer3[i] = EMPTY_VALUE;    ExtMapBuffer4[i] = EMPTY_VALUE;
      
      if(StoOsma > 0)   {ExtMapBuffer3[i] = StoOsma;        ExtMapBuffer4[i] = EMPTY_VALUE;}
      else              {ExtMapBuffer3[i] = EMPTY_VALUE;    ExtMapBuffer4[i] = StoOsma;}
      
      
      }


   return(0);
}

//+------------------------------------------------------------------+