//------------------------------------------------------------------
#property copyright "mladen"
#property link      "mladenfx@gmail.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1  C'0,125,0'
#property indicator_color2  C'0,140,0'
#property indicator_color3  C'0,155,0'
#property indicator_color4  C'0,170,0'
#property indicator_color5  C'0,185,0'
#property indicator_color6  C'0,200,0'
#property indicator_color7  C'0,215,0'
#property indicator_color8  C'0,230,0'
#property indicator_minimum 0
#property indicator_maximum 100

//
//
//
//
//

extern int    StochasticLength1 =  5;
extern int    StochasticLength2 =  8;
extern int    StochasticLength3 = 13;
extern int    StochasticLength4 = 21;
extern int    StochasticLength5 = 34;
extern int    StochasticLength6 = 55;
extern int    StochasticLength7 = 89;
extern int    StochasticLength8 = 144;
extern double SmoothEMA         = 3;
double dssBuffer1[];
double dssBuffer2[];
double dssBuffer3[];
double dssBuffer4[];
double dssBuffer5[];
double dssBuffer6[];
double dssBuffer7[];
double dssBuffer8[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,dssBuffer1);
   SetIndexBuffer(1,dssBuffer2);
   SetIndexBuffer(2,dssBuffer3);
   SetIndexBuffer(3,dssBuffer4);
   SetIndexBuffer(4,dssBuffer5);
   SetIndexBuffer(5,dssBuffer6);
   SetIndexBuffer(6,dssBuffer7);
   SetIndexBuffer(7,dssBuffer8);
      SmoothEMA        = MathMax(1,SmoothEMA);
   IndicatorShortName("DSS Bressert fan");
   return(0);
}
int deinit(){ return(0); }


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars = IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
           int limit = MathMin(Bars-counted_bars,Bars-1);

 	for(int i = limit; i>=0; i--)
 	{
 	    if (StochasticLength1>1)  dssBuffer1[i] = iDss(Close[i],High[i],Low[i],StochasticLength1,SmoothEMA,i,0);
 	    if (StochasticLength2>1)  dssBuffer2[i] = iDss(Close[i],High[i],Low[i],StochasticLength2,SmoothEMA,i,1);
 	    if (StochasticLength3>1)  dssBuffer3[i] = iDss(Close[i],High[i],Low[i],StochasticLength3,SmoothEMA,i,2);
 	    if (StochasticLength4>1)  dssBuffer4[i] = iDss(Close[i],High[i],Low[i],StochasticLength4,SmoothEMA,i,3);
 	    if (StochasticLength5>1)  dssBuffer5[i] = iDss(Close[i],High[i],Low[i],StochasticLength5,SmoothEMA,i,4);
 	    if (StochasticLength6>1)  dssBuffer6[i] = iDss(Close[i],High[i],Low[i],StochasticLength6,SmoothEMA,i,5);
 	    if (StochasticLength7>1)  dssBuffer7[i] = iDss(Close[i],High[i],Low[i],StochasticLength7,SmoothEMA,i,6);
 	    if (StochasticLength8>1)  dssBuffer8[i] = iDss(Close[i],High[i],Low[i],StochasticLength8,SmoothEMA,i,7);
   } 	    
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workDss[][40];
#define _st1    0
#define _ss1    1
#define _pHigh  2
#define _pLow   3
#define _dss    4

double iDss(double close, double high, double low, int length, double smooth, int r, int instanceNo=0)
{
   if (ArrayRange(workDss,0)!=Bars) ArrayResize(workDss,Bars); r=Bars-r-1; instanceNo*=5;
   
   //
   //
   //
   //
   //
   
      double alpha = 2.0 / (1.0+smooth);
         workDss[r][instanceNo+_pHigh]  = high;
         workDss[r][instanceNo+_pLow]   = low;
     
         double min = workDss[r][instanceNo+_pLow];
         double max = workDss[r][instanceNo+_pHigh];
         for (int k=1; k<length && (r-k)>=0; k++)
         {
            min = MathMin(min,workDss[r-k][instanceNo+_pLow]);
            max = MathMax(max,workDss[r-k][instanceNo+_pHigh]);
         }
      
         workDss[r][instanceNo+_st1] = 0;
               if (min!=max) workDss[r][instanceNo+_st1] = 100*(close-min)/(max-min);
         workDss[r][instanceNo+_ss1] = workDss[r-1][instanceNo+_ss1]+alpha*(workDss[r][instanceNo+_st1]-workDss[r-1][instanceNo+_ss1]);

         //
         //
         //
         //
         //
         
         min = workDss[r][instanceNo+_ss1];
         max = workDss[r][instanceNo+_ss1];
         for (k=1; k<length && (r-k)>=0; k++)
         {
            min = MathMin(min,workDss[r-k][instanceNo+_ss1]);
            max = MathMax(max,workDss[r-k][instanceNo+_ss1]);
         }
         double stoch = 0; if (min!=max) stoch = 100*(workDss[r][instanceNo+_ss1]-min)/(max-min);
         
         //
         //
         //
         //
         //
         
          workDss[r][instanceNo+_dss] = workDss[r-1][instanceNo+_dss]+alpha*(stoch -workDss[r-1][instanceNo+_dss]);
   return(workDss[r][instanceNo+_dss]);
}

