//+------------------------------------------------------------------+
//|                                               Filter overWPR.mq4 |
//|                   Copyright  2006, Indoforex Groups - Primajaya |
//|                                   http://primaforex.blogspot.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Indoforex Groups"
#property link      "http://primaforex.blogspot.com"

#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 1.00
#property indicator_buffers 6
#property indicator_color1 Blue
#property indicator_color2 Red
#property indicator_color3 SteelBlue
#property indicator_color4 Orange
#property indicator_color5 SlateGray
#property indicator_color6 DarkGoldenrod

#property indicator_width1 3
#property indicator_width2 3
#property indicator_width3 3
#property indicator_width4 3
#property indicator_width5 3
#property indicator_width6 3


//---- input parameters
extern int PeriodeStoch=14;
extern int PercentD=3;
extern int Smooth=3;
//---- indicator buffers
double UpBuffer1[];
double DnBuffer1[];
double UpBuffer2[];
double DnBuffer2[];
double UpBuffer3[];
double DnBuffer3[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
  int init()
  {
   string short_name;
//---- indicator line
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexStyle(4,DRAW_HISTOGRAM);
   SetIndexStyle(5,DRAW_HISTOGRAM);
  
   SetIndexBuffer(0,UpBuffer1);
   SetIndexBuffer(1,DnBuffer1);
   SetIndexBuffer(2,UpBuffer2);
   SetIndexBuffer(3,DnBuffer2);
   SetIndexBuffer(4,UpBuffer3);
   SetIndexBuffer(5,DnBuffer3);
   
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
//---- name for DataWindow and indicator subwindow label
   short_name="PJ filter overSTO("+PeriodeStoch+") ";
   IndicatorShortName(short_name);
   SetIndexLabel(0,"Strong Bears");
   SetIndexLabel(1,"Strong Bulls");
   SetIndexLabel(2,"Potential to Bulls");
   SetIndexLabel(3,"Potential to Bears");
   
//----
   return(0);
  }

//+------------------------------------------------------------------+
//| ProSol Confirmation                                              |
//+------------------------------------------------------------------+
int start()
  {
   int trend;
   double PK;
   double PD;
  
   int i,limit, counted_bars = IndicatorCounted();
  
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   
   limit=Bars-counted_bars;
   
   
   for(i = limit; i >= 0; i--)   
   
   {	
   
   PK=iStochastic(NULL, 0,PeriodeStoch,PercentD,Smooth,0,0,MODE_MAIN,i);
   PD=iStochastic(NULL, 0,PeriodeStoch,PercentD,Smooth,0,0,MODE_SIGNAL,i);

               bool up=false; bool dn=false;

   if (!up)    {if (PK<PD )trend=4; else trend=6;}
   if (PK>80)  {           trend=1; dn=true;up=false;}

   if (!dn)    {if (PK>PD )trend=3; else trend=5;}
   if (PK<20)  {           trend=2; dn=false;up=true;}

	
	  
	  if (trend==1) 
	  {
	  
	  UpBuffer1[i]=1;
	  DnBuffer1[i]=0;
	  UpBuffer2[i]=0;
	  DnBuffer2[i]=0;
	  UpBuffer3[i]=0;
	  DnBuffer3[i]=0;
	  }
	  if (trend==2) 
	  {
	  
	  UpBuffer1[i]=0;
	  DnBuffer1[i]=1;
	  UpBuffer2[i]=0;
	  DnBuffer2[i]=0;
	  UpBuffer3[i]=0;
	  DnBuffer3[i]=0;
	  
	  }
	  if (trend==3) 
	  {
	   
	  UpBuffer1[i]=0;
	  DnBuffer1[i]=0;
	  UpBuffer2[i]=1;
	  DnBuffer2[i]=0;
	  UpBuffer3[i]=0;
	  DnBuffer3[i]=0;
	  }
	  
	  if (trend==4) 
	  {
	  
	  UpBuffer1[i]=0;
	  DnBuffer1[i]=0;
	  UpBuffer2[i]=0;
	  DnBuffer2[i]=1; 
	  UpBuffer3[i]=0;
	  DnBuffer3[i]=0;
	  }

	  if (trend==5) 
	  {
	  UpBuffer1[i]=0;
	  DnBuffer1[i]=0;
	  UpBuffer2[i]=0;
	  DnBuffer2[i]=0; 
	  UpBuffer3[i]=1;
	  DnBuffer3[i]=0;
	  }
	  if (trend==6) 
	  {
	  UpBuffer1[i]=0;
	  DnBuffer1[i]=0;
	  UpBuffer2[i]=0;
	  DnBuffer2[i]=0; 
	  UpBuffer3[i]=0;
	  DnBuffer3[i]=1;
	  }



	}
	return(0);	
 }

