//+------------------------------------------------------------------+
//|                                                    RSI_angka.mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
//mod2008fxtsd
#property copyright "Copyright  2008, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window
extern int RSI_per   =  12;
extern int RSI_applPrice =   0;
extern string ________ = "";
extern int stoKPeriod=5;
extern int stoDPeriod=3;
extern int stoSlowing=3;
extern int stoMAMethod=0;
extern int stoPriceField=0;

extern string __________  = "";

extern int pos_X = 178;
extern int pos_Y = 154;
extern bool  ShowTFLabelBar = true;
extern color valuesColor = YellowGreen;
double vRSI,vSto,vtfs;
int    tf, x;
string tfs;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   for(int i = ObjectsTotal() - 1; i >= 0; i--)
     {
       string label = ObjectName(i);
       if(StringSubstr(label, 3, 2) != "_a")
           continue;
       ObjectDelete(label);   
     }   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
   int z=1; x=pos_X;
   while (z<=8)
       {
        switch (z)
        {
         case 1: tf =   1; tfs="M1";   break;
         case 2: tf =   5; tfs="M5";   break;
         case 3: tf =  15; tfs="M15";  break;
         case 4: tf =  30; tfs="M30";  break;
         case 5: tf =  60; tfs="H1";   break;
         case 6: tf = 240; tfs="H4";   break;
         case 7: tf =1440; tfs="D1";   break;
         case 8: tf =10080;tfs="W1";   break;

        }


        vRSI = iRSI(0, tf, RSI_per,RSI_applPrice,0); 
        vSto = iStochastic(0,tf,stoKPeriod,stoDPeriod,stoSlowing,stoMAMethod,stoPriceField,0,0);

        x=x-20;
        
        Write("flb_a1",0,1, pos_X+5 ,pos_Y+2,  "RSI", 6, "Verdana", SlateGray);
        Write("flb_a2",0,1, pos_X+5 ,pos_Y+22, "STO", 6, "Verdana", SlateGray);
        
          if (ShowTFLabelBar)
        Write("tfs_a"+DoubleToStr(z,0),0,1, x,pos_Y-15,tfs, 6, "Verdana", SlateGray);
 
        Write("RSI_a"+DoubleToStr(z,0),0,1, x,pos_Y,   DoubleToStr(vRSI,0), 8, "Verdana", valuesColor);
        Write("STO_a"+DoubleToStr(z,0),0,1, x,pos_Y+20,DoubleToStr(vSto,0), 8, "Verdana", valuesColor);




        z++;
       }
//----
   
   return(0);
  }

//+------------------------------------------------------------------+

void Write(string LBL, int window, double side, int pos_x, int pos_y, string text, int fontsize, string fontname, color Tcolor=CLR_NONE)
     {
       ObjectCreate(LBL, OBJ_LABEL, window, 0, 0);
       ObjectSet(LBL, OBJPROP_CORNER, side);
       ObjectSet(LBL, OBJPROP_XDISTANCE, pos_x);
       ObjectSet(LBL, OBJPROP_YDISTANCE, pos_y);
       ObjectSetText(LBL,text, fontsize, fontname, Tcolor);
     }



