//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  DarkGray
#property indicator_color2  DarkGray
#property indicator_color3  DeepSkyBlue
#property indicator_color4  PaleVioletRed
#property indicator_width1  2
#property indicator_width3  2
#property indicator_width4  2
#property indicator_style2  STYLE_DOT
#property indicator_minimum 0
#property indicator_maximum 100

//
//
//
//
//

extern int    Length      = 32;
extern int    Smooth      =  3;
extern int    Signal      =  9;
extern int    SignalMode  = MODE_EMA;
extern int    Price       =  0;
extern double HighLowStep = 0.5;

double stoch[];
double signal[];
double max[];
double min[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
// 
//
//
//
//

int init()
{
   SetIndexBuffer(0,stoch);
   SetIndexBuffer(1,signal);
   SetIndexBuffer(2,max);
   SetIndexBuffer(3,min);
      IndicatorShortName("Corridor stochastic ("+Length+","+Signal+","+Smooth+")");
   return(0);
}
int deinit() { return(0); }

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int k,limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

   for(int i=limit; i>=0; i--)
   {
      stoch[i]  = iStochastic(NULL,0,Length,Signal,Smooth,SignalMode,Price,MODE_MAIN  ,i);
      signal[i] = iStochastic(NULL,0,Length,Signal,Smooth,SignalMode,Price,MODE_SIGNAL,i);
      max[i]    = MathMax(stoch[i],max[i+1]-HighLowStep);
      min[i]    = MathMin(stoch[i],min[i+1]+HighLowStep);
   }         
   return(0);
}