//------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 100
#property indicator_buffers 2
#property indicator_color1 PaleVioletRed
#property indicator_color2 Red
#property indicator_width1 2
#property indicator_style2 STYLE_DOT

//
//
//
//
//

extern int    KPeriod    =14;
extern int    DPeriod    = 3;
extern int    Slowing    = 3;
extern int    MAMode     = 2;
extern int    PriceField = 0;    
extern bool   Double     = true;
extern double Level1     = 80;
extern double Level2     = 20;

//
//
//
//
//

double MainBuffer[];
double SignalBuffer[];
double HighesBuffer[];
double LowesBuffer[];
double MainBuffera[];
double HighesBuffera[];
double LowesBuffera[];
string ShortName;


//------------------------------------------------------------------
//
//------------------------------------------------------------------

int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0, MainBuffer);   SetIndexLabel(0,"Stochastic");
   SetIndexBuffer(1, SignalBuffer); SetIndexLabel(1,"Signal");
   SetIndexBuffer(2, HighesBuffer);
   SetIndexBuffer(3, LowesBuffer);
   SetIndexBuffer(4, HighesBuffera);
   SetIndexBuffer(5, LowesBuffera);
   SetIndexBuffer(6, MainBuffera);
      SetLevelValue(0,Level1);
      SetLevelValue(1,Level2);
   IndicatorShortName("D.stochastic ("+KPeriod+","+DPeriod+","+Slowing+")");
   return(0);
}
int deinit()
{
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for(int i = limit; i >= 0 ; i--)
   {
      if (PriceField==0)
         {
            LowesBuffer[i] = Low[ArrayMinimum(Low ,KPeriod,i)];
            HighesBuffer[i]=High[ArrayMaximum(High,KPeriod,i)];
         }
      else         
         {
            LowesBuffer[i] =Close[ArrayMinimum(Close,KPeriod,i)];
            HighesBuffer[i]=Close[ArrayMaximum(Close,KPeriod,i)];
         }
      
         //
         //
         //
         //
         //
      
         double sumlow  = 0.0;
         double sumhigh = 0.0;
            for(int k=(i+Slowing-1);k>=i;k--)
            {
               sumlow  += Close[k]       -LowesBuffer[k];
               sumhigh += HighesBuffer[k]-LowesBuffer[k];
            }
            if(sumhigh==0.0) 
                  MainBuffera[i] = 100.0;
            else  MainBuffera[i] = sumlow/sumhigh*100.0;

      //
      //
      //
      //
      //
      
      if (Double)
      {
         LowesBuffera[i] =MainBuffera[ArrayMinimum(MainBuffera,KPeriod,i)];
         HighesBuffera[i]=MainBuffera[ArrayMaximum(MainBuffera,KPeriod,i)];
      
         //
         //
         //
         //
         //
      
         sumlow  = 0.0;
         sumhigh = 0.0;
            for(k=(i+Slowing-1);k>=i;k--)
            {
               sumlow  += MainBuffera[k]  -LowesBuffera[k];
               sumhigh += HighesBuffera[k]-LowesBuffera[k];
            }
            if(sumhigh==0.0) 
                  MainBuffer[i] = 100.0;
            else  MainBuffer[i] = sumlow/sumhigh*100.0;
      }
      else MainBuffer[i] = MainBuffera[i];
   }      

   //
   //
   //
   //
   //
         
   for(i=0; i<limit; i++) SignalBuffer[i]=iMAOnArray(MainBuffer,0,DPeriod,0,MAMode,i);
   return(0);
}