//------------------------------------------------------------------
#property copyright "mladen"
#property link      "mladenfx@gmail.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  Orange
#property indicator_width1  2

//
//
//
//
//

extern int    StochasticLength1  = 200;
extern double StochasticDivisor1 = 1;
extern double SmoothEMA1         = 50;
extern int    StochasticLength2  = 100;
extern double StochasticDivisor2 = 2;
extern double SmoothEMA2         = 25;
extern int    StochasticLength3  = 12;
extern double StochasticDivisor3 = 4;
extern double SmoothEMA3         = 3;
extern int    StochasticLength4  = 0;
extern double StochasticDivisor4 = 1;
extern double SmoothEMA4         = 3;
extern int    StochasticLength5  = 0;
extern double StochasticDivisor5 = 1;
extern double SmoothEMA5         = 3;
extern int    StochasticLength6  = 0;
extern double StochasticDivisor6 = 1;
extern double SmoothEMA6         = 3;
extern int    StochasticLength7  = 0;
extern double StochasticDivisor7 = 1;
extern double SmoothEMA7         = 3;
extern int    StochasticLength8  = 0;
extern double StochasticDivisor8 = 1;
extern double SmoothEMA8         = 3;
double dssBuffer[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,dssBuffer);
   IndicatorShortName("DSS Bressert - composite");
   return(0);
}
int deinit(){ return(0); }


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars = IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
           int limit = MathMin(Bars-counted_bars,Bars-1);

 	for(int i = limit; i>=0; i--)
 	{
 	    double dss     = 0;
 	    if (StochasticLength1>1) dss += iDss(Close[i],High[i],Low[i],StochasticLength1,SmoothEMA1,i,0)/StochasticDivisor1;
 	    if (StochasticLength2>1) dss += iDss(Close[i],High[i],Low[i],StochasticLength2,SmoothEMA2,i,1)/StochasticDivisor2;
 	    if (StochasticLength3>1) dss += iDss(Close[i],High[i],Low[i],StochasticLength3,SmoothEMA3,i,2)/StochasticDivisor3;
 	    if (StochasticLength4>1) dss += iDss(Close[i],High[i],Low[i],StochasticLength4,SmoothEMA4,i,3)/StochasticDivisor4;
 	    if (StochasticLength5>1) dss += iDss(Close[i],High[i],Low[i],StochasticLength5,SmoothEMA5,i,4)/StochasticDivisor5;
 	    if (StochasticLength6>1) dss += iDss(Close[i],High[i],Low[i],StochasticLength6,SmoothEMA6,i,5)/StochasticDivisor6;
 	    if (StochasticLength7>1) dss += iDss(Close[i],High[i],Low[i],StochasticLength7,SmoothEMA7,i,6)/StochasticDivisor7;
 	    if (StochasticLength8>1) dss += iDss(Close[i],High[i],Low[i],StochasticLength8,SmoothEMA8,i,7)/StochasticDivisor8;
 	          dssBuffer[i] = dss;
   } 	    
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workDss[][40];
#define _st1    0
#define _ss1    1
#define _pHigh  2
#define _pLow   3
#define _dss    4

double iDss(double close, double high, double low, int length, double smooth, int r, int instanceNo=0)
{
   if (ArrayRange(workDss,0)!=Bars) ArrayResize(workDss,Bars); r=Bars-r-1; instanceNo*=5;
   
   //
   //
   //
   //
   //
   
      double alpha = 2.0 / (1.0+smooth);
         workDss[r][instanceNo+_pHigh]  = high;
         workDss[r][instanceNo+_pLow]   = low;
     
         double min = workDss[r][instanceNo+_pLow];
         double max = workDss[r][instanceNo+_pHigh];
         for (int k=1; k<length && (r-k)>=0; k++)
         {
            min = MathMin(min,workDss[r-k][instanceNo+_pLow]);
            max = MathMax(max,workDss[r-k][instanceNo+_pHigh]);
         }
      
         workDss[r][instanceNo+_st1] = 0;
               if (min!=max) workDss[r][instanceNo+_st1] = 100*(close-min)/(max-min);
         workDss[r][instanceNo+_ss1] = workDss[r-1][instanceNo+_ss1]+alpha*(workDss[r][instanceNo+_st1]-workDss[r-1][instanceNo+_ss1]);

         //
         //
         //
         //
         //
         
         min = workDss[r][instanceNo+_ss1];
         max = workDss[r][instanceNo+_ss1];
         for (k=1; k<length && (r-k)>=0; k++)
         {
            min = MathMin(min,workDss[r-k][instanceNo+_ss1]);
            max = MathMax(max,workDss[r-k][instanceNo+_ss1]);
         }
         double stoch = 0; if (min!=max) stoch = 100*(workDss[r][instanceNo+_ss1]-min)/(max-min);
         
         //
         //
         //
         //
         //
         
          workDss[r][instanceNo+_dss] = workDss[r-1][instanceNo+_dss]+alpha*(stoch -workDss[r-1][instanceNo+_dss]);
   return(workDss[r][instanceNo+_dss]);
}

