//+------------------------------------------------------------------+
//|                                                Stoch_rainbow.mq4 |
//|                                                             Swan |
//|                                  http://ruforum.forexpeoples.com |
//|                                                           eugenk |
//|                                     http://forum.mql4.com/ru/9154|
//|                                                       Dm_35 2008 |
//|                                         http://dimdimych.ucoz.ru |
//+------------------------------------------------------------------+
#property copyright "Dm_35"
#property link      "dm34@mail.ru"
#property indicator_buffers 8
#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 100
#property indicator_color1 Red
#property indicator_color2 Crimson
#property indicator_color3 Yellow
#property indicator_color4 Gold
#property indicator_color5 OliveDrab
#property indicator_color6 Green
#property indicator_color7 RoyalBlue
#property indicator_color8 Blue

#property indicator_levelcolor Gray
#property indicator_level1 20
#property indicator_level2 50
#property indicator_level3 80
extern int KPeriod=8;
extern int Slowing=5;
extern int method=0;
extern int Step=2;//  KPeriod
extern int Count=10;// 
extern int Limit=0;//   

int m;
int Window	= -1;
string Name1;
color Color=0;
double ArrayMain1[];
double ArrayMain2[];
double ArrayMain3[];
double ArrayMain4[];
double ArrayMain5[];
double ArrayMain6[];
double ArrayMain7[];
double ArrayMain8[];
int shifts[7];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  int i;
   if(Count>70) Count=70;
   Name1="Stoch2("+KPeriod+","+Slowing+")";
   IndicatorShortName(Name1);
	IndicatorDigits(2);

   SetIndexBuffer(0, ArrayMain1 );
   SetIndexBuffer(1, ArrayMain2 );
   SetIndexBuffer(2, ArrayMain3 );
   SetIndexBuffer(3, ArrayMain4 );
   SetIndexBuffer(4, ArrayMain5 );
   SetIndexBuffer(5, ArrayMain6 );
   SetIndexBuffer(6, ArrayMain7 );
   SetIndexBuffer(7, ArrayMain8 );
   Window	= -1;

	int shift = Count / 7;

	for( i = 0; i < 7; i++ )
		shifts[ i ] = 1;

	if ( Count > 7 ) {
	int f = ( 7 / shift ) - 1;
	int z = 0;
		for( i = 0; i < 7; i++ ) {
			if ( z == f ) {
				shifts[ i ] = shift;
				z = 0;
			}else{
			z++;
			}
			}

		}
   return(0);

  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

int start()
  {
m=0;

   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
int limit;
if ( counted_bars == 0 ) {
	if ( Limit != 0 )
		limit = Limit;
	else
     limit=MathMin(Bars-counted_bars,Bars-1);

} else {
     limit=MathMin(Bars-counted_bars,Bars-1);
}
int i;
		switch( Count ) {

			case 1:

			   for(i=0;i<limit;i++) {
		         ArrayMain1[i]=iStochastic(NULL,0,KPeriod,1,Slowing,method,0,MODE_MAIN,i);
		         ArrayMain2[i]=EMPTY_VALUE;
		         ArrayMain3[i]=EMPTY_VALUE;
		         ArrayMain4[i]=EMPTY_VALUE;
		         ArrayMain5[i]=EMPTY_VALUE;
		         ArrayMain6[i]=EMPTY_VALUE;
		         ArrayMain7[i]=EMPTY_VALUE;
		         ArrayMain8[i]=EMPTY_VALUE;

				}
				break;

			case 2:

				for(i=0;i<limit;i++) {

			         ArrayMain1[i]=iStochastic(NULL,0,KPeriod,1,Slowing,method,0,MODE_MAIN,i);
			         ArrayMain2[i]=EMPTY_VALUE;
			         ArrayMain3[i]=EMPTY_VALUE;
			         ArrayMain4[i]=EMPTY_VALUE;
		    	     ArrayMain5[i]=EMPTY_VALUE;
		        	 ArrayMain6[i]=EMPTY_VALUE;
			         ArrayMain7[i]=EMPTY_VALUE;
			         ArrayMain8[i]=iStochastic(NULL,0,KPeriod + ( 1 * Step ),1,Slowing,method,0,MODE_MAIN,i);

			      }

				break;

			case 3:
				for(i=0;i<limit;i++) {

			         ArrayMain1[i]=iStochastic(NULL,0,KPeriod,1,Slowing,method,0,MODE_MAIN,i);
			         ArrayMain2[i]=EMPTY_VALUE;
			         ArrayMain3[i]=EMPTY_VALUE;
			         ArrayMain4[i]=iStochastic(NULL,0,KPeriod + ( 1 * Step ),1,Slowing,method,0,MODE_MAIN,i);
		    	     ArrayMain5[i]=EMPTY_VALUE;
		        	 ArrayMain6[i]=EMPTY_VALUE;
			         ArrayMain7[i]=EMPTY_VALUE;
			         ArrayMain8[i]=iStochastic(NULL,0,KPeriod + ( 2 * Step ),1,Slowing,method,0,MODE_MAIN,i);

			      }

				break;
			case 4:
				for(i=0;i<limit;i++) {

			         ArrayMain1[i]=iStochastic(NULL,0,KPeriod,1,Slowing,method,0,MODE_MAIN,i);

			         ArrayMain2[i]=EMPTY_VALUE;
			         ArrayMain3[i]=iStochastic(NULL,0,KPeriod + ( 1 * Step ),1,Slowing,method,0,MODE_MAIN,i);
			         ArrayMain4[i]=EMPTY_VALUE;
			         ArrayMain5[i]=iStochastic(NULL,0,KPeriod + ( 2 * Step ),1,Slowing,method,0,MODE_MAIN,i);
		        	 ArrayMain6[i]=EMPTY_VALUE;
			         ArrayMain7[i]=EMPTY_VALUE;
			         ArrayMain8[i]=iStochastic(NULL,0,KPeriod + ( 3 * Step ),1,Slowing,method,0,MODE_MAIN,i);

			      }

				break;
			case 5:
				for(i=0;i<limit;i++) {

			         ArrayMain1[i]=iStochastic(NULL,0,KPeriod,1,Slowing,method,0,MODE_MAIN,i);

			         ArrayMain2[i]=EMPTY_VALUE;
			         ArrayMain3[i]=iStochastic(NULL,0,KPeriod + ( 1 * Step ),1,Slowing,method,0,MODE_MAIN,i);
			         ArrayMain4[i]=EMPTY_VALUE;
			         ArrayMain5[i]=iStochastic(NULL,0,KPeriod + ( 2 * Step ),1,Slowing,method,0,MODE_MAIN,i);
			         ArrayMain6[i]=iStochastic(NULL,0,KPeriod + ( 3 * Step ),1,Slowing,method,0,MODE_MAIN,i);
			         ArrayMain7[i]=EMPTY_VALUE;
			         ArrayMain8[i]=iStochastic(NULL,0,KPeriod + ( 4 * Step ),1,Slowing,method,0,MODE_MAIN,i);

			      }

				break;
			case 6:
				for(i=0;i<limit;i++) {

			         ArrayMain1[i]=iStochastic(NULL,0,KPeriod,1,Slowing,method,0,MODE_MAIN,i);

			         ArrayMain2[i]=EMPTY_VALUE;
			         ArrayMain3[i]=iStochastic(NULL,0,KPeriod + ( 1 * Step ),1,Slowing,method,0,MODE_MAIN,i);
			         ArrayMain4[i]=iStochastic(NULL,0,KPeriod + ( 2 * Step ),1,Slowing,method,0,MODE_MAIN,i);
			         ArrayMain5[i]=iStochastic(NULL,0,KPeriod + ( 3 * Step ),1,Slowing,method,0,MODE_MAIN,i);
			         ArrayMain6[i]=iStochastic(NULL,0,KPeriod + ( 4 * Step ),1,Slowing,method,0,MODE_MAIN,i);
			         ArrayMain7[i]=EMPTY_VALUE;
			         ArrayMain8[i]=iStochastic(NULL,0,KPeriod + ( 5 * Step ),1,Slowing,method,0,MODE_MAIN,i);

			      }

				break;
			case 7:
				for(i=0;i<limit;i++) {

			         ArrayMain1[i]=iStochastic(NULL,0,KPeriod,1,Slowing,method,0,MODE_MAIN,i);

			         ArrayMain2[i]=iStochastic(NULL,0,KPeriod + ( 1 * Step ),1,Slowing,method,0,MODE_MAIN,i);
			         ArrayMain3[i]=iStochastic(NULL,0,KPeriod + ( 2 * Step ),1,Slowing,method,0,MODE_MAIN,i);
			         ArrayMain4[i]=iStochastic(NULL,0,KPeriod + ( 3 * Step ),1,Slowing,method,0,MODE_MAIN,i);
			         ArrayMain5[i]=iStochastic(NULL,0,KPeriod + ( 4 * Step ),1,Slowing,method,0,MODE_MAIN,i);
			         ArrayMain6[i]=iStochastic(NULL,0,KPeriod + ( 5 * Step ),1,Slowing,method,0,MODE_MAIN,i);
			         ArrayMain7[i]=EMPTY_VALUE;
			         ArrayMain8[i]=iStochastic(NULL,0,KPeriod + ( 6 * Step ),1,Slowing,method,0,MODE_MAIN,i);

			      }

				break;

			default:

				for(i=0;i<limit;i++) {

			         ArrayMain1[i]=iStochastic(NULL,0,KPeriod,1,Slowing,method,0,MODE_MAIN,i);

			         ArrayMain2[i]=iStochastic(NULL,0,KPeriod + ( ( 1 * shifts[ 0 ] ) * Step ),1,Slowing,method,0,MODE_MAIN,i);

			         ArrayMain3[i]=iStochastic(NULL,0,KPeriod + ( ( 2 * shifts[ 1 ] ) * Step ),1,Slowing,method,0,MODE_MAIN,i);
			         ArrayMain4[i]=iStochastic(NULL,0,KPeriod + ( ( 3 * shifts[ 2 ] ) * Step ),1,Slowing,method,0,MODE_MAIN,i);
			         ArrayMain5[i]=iStochastic(NULL,0,KPeriod + ( ( 4 * shifts[ 3 ] ) * Step ),1,Slowing,method,0,MODE_MAIN,i);
			         ArrayMain6[i]=iStochastic(NULL,0,KPeriod + ( ( 5 * shifts[ 4 ] ) * Step ),1,Slowing,method,0,MODE_MAIN,i);
			         ArrayMain7[i]=iStochastic(NULL,0,KPeriod + ( ( 6 * shifts[ 5 ] ) * Step ),1,Slowing,method,0,MODE_MAIN,i);
			         ArrayMain8[i]=iStochastic(NULL,0,KPeriod + ( ( 7 * shifts[ 6 ] ) * Step ),1,Slowing,method,0,MODE_MAIN,i);

			      }

				break;

			}
   return(0);
  }

