//-----------------------------------------------------------------------
#property copyright "www.forex-tsd.com, modified by airquest@hotmail.com"
#property link      "www.forex-tsd.com, modified by airquest@hotmail.com"
//-----------------------------------------------------------------------

#property indicator_separate_window
#property indicator_buffers   2
#property indicator_color1    LimeGreen
#property indicator_color2    Orange
#property indicator_style2    STYLE_DOT
#property indicator_width1    2
#property indicator_minimum  -5
#property indicator_maximum 105
#property indicator_level1   80
#property indicator_level2   20
#property indicator_levelcolor DarkGray

//
//
//
//
//

extern int    StochasticPeriod       = 50;
extern int    StochasticSignalPeriod = 10;
extern int    MaMetod   = 2;
extern int    MaPeriod  = 6;
extern int    MaMetod2  = 3;
extern int    MaPeriod2 = 2;

//
//
//
//
//

double buffer1[];
double buffer2[];
double buffer3[];
double ExtMapBuffer1[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,buffer1);
   SetIndexBuffer(1,buffer2);
   SetIndexBuffer(2,buffer3);
   SetIndexBuffer(3,ExtMapBuffer1);
   IndicatorShortName("Stochastic of HAMA ("+MaPeriod+","+MaMetod+","+MaPeriod2+","+MaMetod2+")");
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   double maOpen, maClose, maLow, maHigh, haClose;
   
   int counted_bars = IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
   
   //
   //
   int pos=Bars-counted_bars-1;
   while(pos>=0)
     {
      maOpen  =iMA(NULL,0,MaPeriod,0,MaMetod,PRICE_OPEN,pos);
      maClose =iMA(NULL,0,MaPeriod,0,MaMetod,PRICE_CLOSE,pos);
      maLow   =iMA(NULL,0,MaPeriod,0,MaMetod,PRICE_LOW,pos);
      maHigh  =iMA(NULL,0,MaPeriod,0,MaMetod,PRICE_HIGH,pos);

      haClose=(maOpen+maHigh+maLow+maClose)/4;
      ExtMapBuffer1[pos]=haClose;

 	   pos--;
     }
   //
   //

   double alpha = 2.0 / (1.0 + StochasticSignalPeriod);
   for(int i=limit; i>=0; i--)
   {
      buffer3[i] = iMAOnArray(ExtMapBuffer1,Bars,MaPeriod2,0,MaMetod2,i);
      
      //
      //
      //
      //
      //
      
      double hi = buffer3[ArrayMaximum(buffer3,StochasticPeriod,i)];
      double lo = buffer3[ArrayMinimum(buffer3,StochasticPeriod,i)];
      if (hi != lo)
            buffer1[i] = 100*(buffer3[i]-lo)/(hi-lo);
      else  buffer1[i] = 0.00;
      if (StochasticSignalPeriod>1)
            buffer2[i] = buffer2[i+1] + alpha*(buffer1[i]-buffer2[i+1]);
   }         
   return(0);
}

//
//
//
//------------------------------------------------------------------