//+-------------------------------------------------------------------------------+ 
//|                   stoch rbci.mq4                                              | 
//+-------------------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  LimeGreen
#property indicator_color2  Red
#property indicator_color3  Red
#property indicator_color4  Gold
#property indicator_style4  STYLE_DOT
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_minimum -5
#property indicator_maximum 105
#property indicator_level1  20
#property indicator_level2  80

//
//
//
//
//

extern int StoPeriod       = 14;
extern int StoSlowing      = 7;
extern int StoSignal       = 5;
extern int StoSignalMethod = MODE_LWMA;


double stoch[];
double stochda[];
double stochdb[];
double signal[];
double slope[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
    IndicatorBuffers(5);
    SetIndexBuffer(0,stoch);
    SetIndexBuffer(1,stochda);
    SetIndexBuffer(2,stochdb);
    SetIndexBuffer(3,signal);
    SetIndexBuffer(4,slope);
    IndicatorShortName("Stochastic rbci ("+StoPeriod+","+StoSlowing+","+StoSignal+")");
return(0);
}
int deinit() { return(0); }

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   if (slope[limit]==-1) CleanPoint(limit,stochda,stochdb);
   for (i=limit; i>=0; i--)
   {
      double value1   =    0.1238169269451*Close[i]
                          +0.1221983501658*Close[i+1]
                          +0.1190011430108*Close[i+2]
                          +0.1143001746257*Close[i+3]
                          +0.1082083357775*Close[i+4]
                          +0.1008691117824*Close[i+5]
                          +0.0924544579826*Close[i+6]
                          +0.0831591882460*Close[i+7]
                          +0.0731968216651*Close[i+8]
                          +0.0627911325011*Close[i+9]
                          +0.0521720176304*Close[i+10]
                          +0.0415674676220*Close[i+11]
                          +0.03120052346999*Close[i+12]
                          +0.02127741353836*Close[i+13]
                          +0.01198981966718*Close[i+14]
                          +0.00350383519239*Close[i+15]
                          -0.00404130034650*Close[i+16]
                          -0.01053553119457*Close[i+17]
                          -0.01590136845728*Close[i+18]
                          -0.02009560547438*Close[i+19]
                          -0.02310598643001*Close[i+20]
                          -0.02495565070371*Close[i+21]
                          -0.02569543732024*Close[i+22]
                          -0.02540610735631*Close[i+23]
                          -0.02418933707968*Close[i+24]
                          -0.02217041377021*Close[i+25]
                          -0.01948743120540*Close[i+26]
                          -0.01629007442301*Close[i+27]
                          -0.01273209112891*Close[i+28]
                          -0.00897092800794*Close[i+29]
                          -0.00515330395028*Close[i+30]
                          -0.001424610881936*Close[i+31]
                          +0.002089714906396*Close[i+32]
                          +0.00527492988233*Close[i+33]
                          +0.00803981322228*Close[i+34]
                          +0.01031021336959*Close[i+35]
                          +0.01203833709278*Close[i+36]
                          +0.01319390261994*Close[i+37]
                          +0.01377360958119*Close[i+38]
                          +0.01379122900470*Close[i+39]
                          +0.01328501259881*Close[i+40]
                          +0.01230273314848*Close[i+41]
                          +0.01091362242228*Close[i+42]
                          +0.00919300646953*Close[i+43]
                          +0.00722551890827*Close[i+44]
                          +0.00509973699629*Close[i+45]
                          +0.002906438043441*Close[i+46]
                          +0.000729911949400*Close[i+47]
                          -0.001346036589003*Close[i+48]
                          -0.00325210803091*Close[i+49]
                          -0.00492308867006*Close[i+50]
                          -0.00631171934917*Close[i+51]
                          -0.00737835671608*Close[i+52]
                          -0.00810443966122*Close[i+53]
                          -0.00847884560573*Close[i+54]
                          -0.00850814309603*Close[i+55]
                          -0.00820791786681*Close[i+56]
                          -0.00761322935395*Close[i+57]
                          -0.00675617201370*Close[i+58]
                          -0.00569105890365*Close[i+59]
                          -0.00446463210704*Close[i+60]
                          -0.003136445450683*Close[i+61]
                          -0.001759234808441*Close[i+62]
                          -0.000391899232101*Close[i+63]
                          +0.000916713292996*Close[i+64]
                          +0.002115501258662*Close[i+65]
                          +0.00316846373575*Close[i+66]
                          +0.00404050173851*Close[i+67]
                          +0.00471194761689*Close[i+68]
                          +0.00516189438300*Close[i+69]
                          +0.00539023783301*Close[i+70]
                          +0.00540028907392*Close[i+71]
                          +0.00520072700713*Close[i+72]
                          +0.00481262249830*Close[i+73]
                          +0.00426189211234*Close[i+74]
                          +0.00357578092340*Close[i+75]
                          +0.002792791011630*Close[i+76]
                          +0.001945190969686*Close[i+77]
                          +0.001074072336198*Close[i+78]
                          +0.0002102221385011*Close[i+79]
                          -0.000610258489301*Close[i+80]
                          -0.001362909162372*Close[i+81]
                          -0.002016921408291*Close[i+82]
                          -0.002553050522480*Close[i+83]
                          -0.002955099512448*Close[i+84]
                          -0.00322723217731*Close[i+85]
                          -0.00334694099100*Close[i+86]
                          -0.00333535479504*Close[i+87]
                          -0.00319005665285*Close[i+88]
                          -0.002930348894442*Close[i+89]
                          -0.002568261433140*Close[i+90]
                          -0.002127236248681*Close[i+91]
                          -0.001623259096604*Close[i+92]
                          -0.001082462836013*Close[i+93]
                          -0.000522606151926*Close[i+94]
                          +0.00002812805821277*Close[i+95]
                          +0.000550592842051*Close[i+96]
                          +0.001019101013467*Close[i+97]
                          +0.001432459831088*Close[i+98]
                          +0.001802313902175*Close[i+99]
                          +0.002066320467808*Close[i+100]
                          +0.002267449265120*Close[i+101]
                          +0.002390634801585*Close[i+102]
                          +0.002440016443207*Close[i+103]
                          +0.002428710369870*Close[i+104]
                          +0.002363019645587*Close[i+105]
                          +0.002261631402824*Close[i+106]
                          +0.002135750325722*Close[i+107]
                          +0.002007788917687*Close[i+108]
                          +0.001891663701696*Close[i+109]
                          +0.001811330494697*Close[i+110]
                          +0.001782108479675*Close[i+111]
                          +0.001828472108508*Close[i+112]
                          -0.00923028648226*Close[i+113];

           //
           //
           //
           //
           //
           
           double value2 = 0.0982862174*Close[i+0] 
                          +0.0975682269*Close[i+1] 
                          +0.0961401078*Close[i+2] 
                          +0.0940230544*Close[i+3] 
                          +0.0912437090*Close[i+4] 
                          +0.0878391006*Close[i+5] 
                          +0.0838544303*Close[i+6] 
                          +0.0793406350*Close[i+7] 
                          +0.0743569346*Close[i+8] 
                          +0.0689666682*Close[i+9] 
                          +0.0632381578*Close[i+10] 
                          +0.0572428925*Close[i+11] 
                          +0.0510534242*Close[i+12] 
                          +0.0447468229*Close[i+13] 
                          +0.0383959950*Close[i+14] 
                          +0.0320735368*Close[i+15] 
                          +0.0258537721*Close[i+16] 
                          +0.0198005183*Close[i+17] 
                          +0.0139807863*Close[i+18] 
                          +0.0084512448*Close[i+19] 
                          +0.0032639979*Close[i+20] 
                          -0.0015350359*Close[i+21] 
                          -0.0059060082*Close[i+22] 
                          -0.0098190256*Close[i+23] 
                          -0.0132507215*Close[i+24] 
                          -0.0161875265*Close[i+25] 
                          -0.0186164872*Close[i+26] 
                          -0.0205446727*Close[i+27] 
                          -0.0219739146*Close[i+28] 
                          -0.0229204861*Close[i+29] 
                          -0.0234080863*Close[i+30] 
                          -0.0234566315*Close[i+31] 
                          -0.0231017777*Close[i+32] 
                          -0.0223796900*Close[i+33] 
                          -0.0213300463*Close[i+34] 
                          -0.0199924534*Close[i+35] 
                          -0.0184126992*Close[i+36] 
                          -0.0166377699*Close[i+37] 
                          -0.0147139428*Close[i+38] 
                          -0.0126796776*Close[i+39] 
                          -0.0105938331*Close[i+40] 
                          -0.0084736770*Close[i+41] 
                          -0.0063841850*Close[i+42] 
                          -0.0043466731*Close[i+43] 
                          -0.0023956944*Close[i+44] 
                          -0.0005535180*Close[i+45] 
                          +0.0011421469*Close[i+46] 
                          +0.0026845693*Close[i+47] 
                          +0.0040471369*Close[i+48] 
                          +0.0052380201*Close[i+49] 
                          +0.0062194591*Close[i+50] 
                          +0.0070340085*Close[i+51] 
                          +0.0076266453*Close[i+52] 
                          +0.0080376628*Close[i+53] 
                          +0.0083037666*Close[i+54] 
                          +0.0083694798*Close[i+55] 
                          +0.0082901022*Close[i+56] 
                          +0.0080741359*Close[i+57] 
                          +0.0077543820*Close[i+58] 
                          +0.0073260526*Close[i+59] 
                          +0.0068163569*Close[i+60] 
                          +0.0062325477*Close[i+61] 
                          +0.0056078229*Close[i+62] 
                          +0.0049516078*Close[i+63] 
                          +0.0161380976*Close[i+64];

     double rbci = (value1 - value2);
     stoch[i]    = iStoch(rbci,rbci,rbci,StoPeriod,StoSlowing,i,0);
     stochda[i]  = EMPTY_VALUE;
     stochdb[i]  = EMPTY_VALUE;
     slope[i]    = slope[i+1];
         if (stoch[i]>stoch[i+1]) slope[i] =  1;
         if (stoch[i]<stoch[i+1]) slope[i] = -1;
         if (slope[i] == -1) PlotPoint(i,stochda,stochdb,stoch);
   }         
   for (i=limit; i>=0; i--) signal[i] = iMAOnArray(stoch,0,StoSignal,0,StoSignalMethod,i);
   return(0);
} 

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//

double workSto[][5];
#define _hi 0
#define _lo 1
#define _re 2
#define _ma 3
#define _mi 4
double iStoch(double priceR, double priceH, double priceL, int period, int slowing, int i, int instanceNo=0)
{
   if (ArrayRange(workSto,0)!=Bars) ArrayResize(workSto,Bars); i = Bars-i-1; instanceNo *= 5;
   
   //
   //
   //
   //
   //
   
   workSto[i][_hi+instanceNo] = priceH;
   workSto[i][_lo+instanceNo] = priceL;
   workSto[i][_re+instanceNo] = priceR;
   workSto[i][_ma+instanceNo] = priceH;
   workSto[i][_mi+instanceNo] = priceL;
      for (int k=1; k<period && (i-k)>=0; k++)
      {
         workSto[i][_mi+instanceNo] = MathMin(workSto[i][_mi+instanceNo],workSto[i-k][instanceNo+_lo]);
         workSto[i][_ma+instanceNo] = MathMax(workSto[i][_ma+instanceNo],workSto[i-k][instanceNo+_hi]);
      }                   
      double sumlow  = 0.0;
      double sumhigh = 0.0;
      for(k=0; k<slowing; k++)
      {
         sumlow  += workSto[i-k][_re+instanceNo]-workSto[i-k][_mi+instanceNo];
         sumhigh += workSto[i-k][_ma+instanceNo]-workSto[i-k][_mi+instanceNo];
      }

   //
   //
   //
   //
   //
   
   if(sumhigh!=0.0) 
         return(100.0*sumlow/sumhigh);
   else  return(0);    
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
         {
            if (first[i+2] == EMPTY_VALUE) 
                 { first[i]  = from[i]; first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
            else { second[i] = from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
         }
   else  { first[i] = from[i]; second[i] = EMPTY_VALUE; }
}